unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,plot1,printers;

type
  TForm4 = class(TForm)
    Image1: TImage;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure grid(Sender: TObject);
    procedure seekey(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure readppp(nd:integer);

var
  Form4: TForm4;
  ax,ay,bx,by,i02,j02,k02:single;
  centerx,centery:integer;
  lshade:boolean;
  rtx,rty,rtz:boolean;

  procedure dummyread;{read the whole file in order to get atomic coordinates}

implementation

uses Unit2, Unit5, Unit6,  Unit8, Unit12,jpeg, Unit7,math;
const numberofcubes=50000;nuco=50;
      const ha=27.21161;{Volts - atomic units of potential}
      nmax=260;


type
     cl=record
      z:single;{cube middle z coordinate}
      x,y:array[1..nuco] of smallint;{coordinates of the corners}
      bt:array[1..nuco,1..2] of byte;
      corners:smallint;
      tcl:array[1..nuco] of tcolor;
      potential:array[1..nuco] of single;
     end;
     vector=array[1..3] of single;

var
    x0,y0,z0,dx,dy,dz:single;
    filt:file;
    hideback:boolean;
    tile:array[0..numberofcubes] of cl;
{    ttl:cl;}
    f4:single;
    xy:array[1..nuco] of tpoint;
    acl:tcolor;
    iimin,jjmin,iimax,jjmax:integer;
    baw:boolean;
    pmin,pmax:real;
    nd:smallint;
    item:smallint;
    name:string[81];
    icube,ncube:longint;
    ntem:longint;
    ftem:file;
    xyzf:textfile;


{$R *.DFM}


procedure dummyread;{read the whole file in order to get atomic coordinates}
var filt:file;
    name:string[81];
    noa,i0,j0,k0,nd:smallint;
    x0,y0,a,z0,dx,dy,dz:single;
    i,j,k,l:integer;
begin
assignfile(filt,'den.ppp');reset(filt,1);{recsize:=1;}
blockread(filt,name,82);
blockread(filt,nd,2);
blockread(filt,i0,2);blockread(filt,j0,2);blockread(filt,k0,2);
blockread(filt,x0,4);blockread(filt,y0,4);blockread(filt,z0,4);
blockread(filt,dx,4);blockread(filt,dy,4);blockread(filt,dz,4);
for i:=0 to i0 do begin for j:=0 to j0 do begin for k:=0 to k0 do begin
  blockread(filt,a,4);if nd=4 then blockread(filt,a,4);
end;end;end;
blockread(filt,noa,4);natoms:=noa;
if noa>nat0 then begin
 MessageDlg('noa='+inttostr(noa)+' Too many atoms, limit='+inttostr(nat0)+'!',mtinformation,[mbOK],0);
 exit;
end;
for l:=1 to noa do for i:=1 to 3 do blockread(filt,ratoms[i,l],8);
for l:=1 to noa do blockread(filt,qatoms[l],8);
closefile(filt);
end;

procedure si(var i,j:integer);var k:integer;
begin k:=i;i:=j;j:=k;end;

procedure drawlabels;
var i:integer;paper:tcanvas;
begin
 if lprint then paper:=printer.canvas else paper:=bitmap.canvas;
 for i:=1 to abs(llab) do begin
  with paper do begin
   brush.style:=bsclear;
   font.size:=labs[i];
   font.color:=labc[i];
   font.name:=labn[i];
   textout(round(labx[i]*xgm),round(laby[i]*ygm),labstr[i]);
  end;
 end;
 if not(lprint) then form4.image1.picture.graphic:=bitmap;
end;

procedure setp(var nro1,nro2:integer;a,b,ros:real);
begin
 nro1:=trunc(a/ros);
 if (b>a) and (b>0) then nro1:=nro1+1;
 if (b<a) and (b<0) then nro1:=nro1-1;
 nro2:=trunc(b/ros);
 if (a>b) and (a>0) then nro2:=nro2+1;
 if (a<b) and (a<0) then nro2:=nro2-1;
 if nro1>nro2 then si(nro1,nro2);
end;

procedure t3(ai,aj,ak:single;var x,y:integer);
begin
 x:=centerx+round(zoom*(ax*(i02+(ai-i02)*atr[1,1]+(aj-j02)*atr[1,2]+(ak-k02)*atr[1,3])+bx-xgm div 2));
 y:=centery+round(zoom*(ay*(j02+(ai-i02)*atr[2,1]+(aj-j02)*atr[2,2]+(ak-k02)*atr[2,3])+by-ygm div 2));
end;

function zz(ai,aj,ak:real):single;
begin
 zz:=ai*atr[3,1]+aj*atr[3,2]+ak*atr[3,3];
end;

procedure ln(x1,y1,x2,y2:integer);
var paper:tcanvas;
begin
 if lprint then paper:=printer.canvas else paper:=bitmap.canvas;
 with paper do begin
  moveto(x1,y1);pixels[x1,y1]:=pen.color;lineto(x2,y2);pixels[x2,y2]:=pen.color;
 end;
end;


function fb(var a,b,ro:single):boolean;
begin
fb:=(((a<ro) and (ro<b)) or ((a>ro) and (ro>b))) and ((a<>0) or (b<>0));
end;


procedure plotatoms(var f:file);
var noa:longint;r:array[1..3,1..nat0] of double;
    q:array[1..nat0] of double;
    z:array[1..nat0] of integer;
    id,ix,iy,iz,x1,x2,y1,y2:integer;
    l,ll,i:integer;
    x,y,zz,bl,xl,yl,zl:real;
    paper:tcanvas;
begin
{Loadatoms}
 blockread(f,noa,4);
 if noa>nat0 then begin
  MessageDlg('noa='+inttostr(noa)+' Too many atoms, limit='+inttostr(nat0)+'!',mtinformation,[mbOK],0);
  exit;
 end;
 for l:=1 to noa do for i:=1 to 3 do blockread(f,r[i,l],8);
 natoms:=noa; for l:=1 to noa do for i:=1 to 3 do ratoms[i,l]:=r[i,l];
 for l:=1 to noa do begin   blockread(f,q[l],8);z[l]:=round(q[l]);end;
 if lprint then paper:=printer.canvas   else    paper:=bitmap.canvas;
 with paper do begin
  if lprint then pen.width:=2 else pen.width:=1;
  pen.style:=pssolid;
  pen.color:=clblack;
  for l:=1 to noa do begin
   xl:=r[1,l];yl:=r[2,l];zl:=r[3,l];bl:=bonding[z[l]];
   t3(xl/dx,yl/dy,zl/dz,x1,y1);
   for ll:=l+1 to noa do begin
    {bonding is in A but here we have aus}
    if sqr(xl-r[1,ll])+sqr(yl-r[2,ll])+sqr(zl-r[3,ll])<sqr((bl+bonding[z[ll]])/bohr) then begin
     t3(r[1,ll]/dx,r[2,ll]/dy,r[3,ll]/dz,x2,y2);
     if plotter then begin
      writeln(fhgl,'PU'+inttostr(x1)+','+inttostr(y1)+';');
      writeln(fhgl,'PD'+inttostr(x2)+','+inttostr(y2)+';');
      writeln(fhgl,'PU;');
     end else ln(x1,y1,x2,y2);
    end;
   end;
  end;
  pen.width:=1;
 end;
 if form2.checkbox7.checked and (nd>2) then {make a file for mcm95} begin
  assignfile(ftem,'tem.scr');
  assignfile(xyzf,'FILE.X');
  reset(ftem,2);
  rewrite(xyzf);
  writeln(xyzf,'atoms and orbitals from density plots');
  writeln(xyzf,-noa-ntem);
  for i:=1 to noa do writeln(xyzf,q[i]:3:0,r[1,i]*bohr:12:6,r[2,i]*bohr:12:6,r[3,i]*bohr:12:6,' 0 0 0 0 0 0 0 0.0');
  for i:=1 to ntem do begin
   blockread(ftem,id,2);blockread(ftem,ix,2);blockread(ftem,iy,2);blockread(ftem,iz,2);
   x:=(dx*ix)*bohr;
   y:=(dy*iy)*bohr;
   zz:=(dz*iz)*bohr;
   writeln(xyzf,id:3,x:12:6,y:12:6,zz:12:6,' 0 0 0 0 0 0 0 0.0');
  end;
  closefile(xyzf);
  closefile(ftem);
 end;
end;

procedure t2(i,j:single;var x,y:integer);
begin x:=round(ax*i+bx);y:=round(ay*j+by);end;

procedure pixel(x,y:integer);
var paper:tcanvas;
begin
 if lprint then paper:=printer.canvas else paper:=bitmap.canvas;
 paper.moveto(x,y);paper.lineto(x+1,y);
end;

function sese(vi,fi,va:real):tcolor;
{vi ; minimum,fi-current,va-maximum}
var red,green,blue:tcolor;delv,d2,d4,z0:real;
begin
 if fi>va then fi:=va;if fi<vi then fi:=vi;
 delv:=va-vi;d2:=0.5*delv;z0:=(va+vi)*0.5;d4:=0.5*d2;
 if fi> z0+d4 then red :=255 else if fi<z0 then red :=0 else red :=round(255*(fi-z0)/d4);
 if fi< z0-d4 then blue:=255 else if fi>z0 then blue:=0 else blue:=round(255*(z0-fi)/d4);
 if (fi<vi)or(fi>va) then green:=0 else if fi<z0-d4 then
 green:=round(255*(fi-vi)/d4) else if fi>z0+d4 then
 green:=round(255*(va-fi)/d4) else
 green:=255;
 sese:=red+256*(256*blue+green);
end;

procedure scpp(var pcolor:tcolor;pmax,pmin:real;f4:single);
var iblue,ired,igreen:tcolor;z0,d,d4:real;
begin
 pcolor:=sese(pmin,f4,pmax);exit;
 z0:=0.5*(pmax+pmin);d:=pmax-pmin;d4:=0.25*d;
 if not(baw)then begin
  if f4<pmin+d4 then iblue:=256*256*255 else begin
   if f4<z0 then iblue:=256*256*round(((z0-f4)*1020)/d) else iblue:=0;
  end;
  if f4>pmax-d4 then ired:=255 else begin
   if f4>z0 then ired:=round(((f4-z0)*1020)/d) else ired :=0;
  end;
  if f4<pmin+d4 then begin
   if f4>pmin then igreen:=256*round(1020*(f4-pmin)/d) else igreen:=0;
  end else begin
   if f4>pmax-d4 then begin
    if f4<pmax then igreen:=256*round(1020*(pmax-f4)/d) else igreen:=0;
   end else igreen:=256*255;
  end;
 end else begin
  if f4<pmin then ired:=0 else begin
   if f4>pmax then ired:=255 else begin
    ired:=round(255*(f4-pmin)/d);
   end;
  end;
  igreen:=ired*256;iblue:=igreen*256;
 end;
 pcolor:=iblue+ired+igreen;
end;

procedure esscale;
var x1,x2:smallint;
    paper:tcanvas;ss:string;
    cc:tcolor;
    ya,ys,i:integer;
    xs,dd,py,wy,lx:real;
begin
 py:=strtofloat(form12.edit1.text);
 wy:=strtofloat(form12.edit2.text);
 lx:=strtofloat(form12.edit3.text);
 xs:=xgm*(1-lx)/2;
 ys:=round(ygm*py-ygm*wy/2);
 ya:=round(ygm*py+ygm*wy/2);
 if lprint then paper:=printer.canvas else paper:=bitmap.canvas;
 with paper do begin
  brush.style:=bsclear;font:=form12.fontdialog1.font;
  str(pmin*ha:12:7,ss);
  textout(round(xs),round(ya+ygm*wy/2),ss);
  str(pmax*ha:12:7,ss);
  textout(round(xgm*(1+lx)/2),round(ya+ygm*wy/2),ss);
  dd:=(pmax-pmin)/256;
  brush.style:=bssolid;
  for i:=1 to 256 do begin
   scpp(cc,pmax,pmin,pmin+dd*i);brush.color:=cc;pen.color:=cc;
   x1:=round(xs + i*xgm*lx/256);
   x2:=round(xs + (i+1)*xgm*lx/256);
   rectangle(x1,ys,x2,ya);
  end;
 end;
end;


procedure seecube2(ii,jj,kk:integer;var icu,icut:smallint;x1,y1,x2,y2:smallint);
label l1,l2,l3;
var j,i:smallint;ico1,ico2:byte;
begin
 icu:=icu+1;if icu>1 then exit;
 icut:=icut+1;{number of lines in current cube}
 if icut=1 then begin icube:=icube+1;{for icut=1 create new tile}
  if icube>numberofcubes then begin
   form2.caption:='too many cubes encountered';form4.close;
  end;
  with tile[icube] do begin
   for j:=1 to nuco do begin
    bt[j,1]:=0;bt[j,2]:=0;
   end;
   z:=0;
   potential[1]:=f4;   potential[2]:=f4;
   tcl[1]:=acl;x[1]:=x1;y[1]:=y1;tcl[2]:=acl;x[2]:=x2;y[2]:=y2;
   corners:=2;bt[1,1]:=2;bt[2,1]:=1;
   if (x1=x2) and (y1=y2) then corners:=1;
   z:=zz(ii-0.5,jj-0.5,kk-0.5);
  end;
 end else begin {add the corners into the tile}
  with tile[icube] do begin
   for i:=1 to corners do begin {check, if first allready in}
    if (x[i]=x1) and (y[i]=y1) then begin ico1:=i;goto l1; end;
   end;
   corners:=corners+1;ico1:=corners;tcl[corners]:=acl;potential[corners]:=f4;
   x[corners]:=x1;y[corners]:=y1;
   l1:
   if (x1=x2) and (y1=y2) then goto l3;
   for i:=1 to corners do begin {check, if second allready in}
    if (x[i]=x2) and (y[i]=y2) then begin ico2:=i;goto l2;end;
   end;
   corners:=corners+1;
   if corners>nuco then begin
    form2.caption:='too many cubes corners';form4.close;
   end;
   ico2:=corners;tcl[corners]:=acl;potential[corners]:=f4;
   x[corners]:=x2;y[corners]:=y2;
   l2:
   {connect them}
   if bt[ico1,1]=0 then bt[ico1,1]:=ico2 else begin
    if bt[ico1,1]<>ico2 then bt[ico1,2]:=ico2;
   end;
   if bt[ico2,1]=0 then bt[ico2,1]:=ico1 else begin
    if bt[ico2,1]<>ico1 then bt[ico2,2]:=ico1;
   end;

   l3:

  end;{with tile}
 end;{if icut<>1}
end;

function dp(a,b:vector):single;
begin
 dp:=a[1]*b[1]+a[2]*b[2]+a[3]*b[3];
end;

procedure vp(a,b:vector;var c:vector);
begin
 c[1]:=a[2]*b[3]-a[3]*b[2];c[2]:=a[3]*b[1]-a[1]*b[3];c[3]:=a[1]*b[2]-a[2]*b[1];
end;

procedure norm(var a:vector);var aa:single;
begin
 aa:=1/sqrt(dp(a,a));a[1]:=a[1]*aa;a[2]:=a[2]*aa;a[3]:=a[3]*aa;
end;

procedure setscale2;
var zoom:real;
    imax:real;
begin
 zoom:=strtofloat(form2.edit3.text);
 imax:=strtoint(form7.edit23.text);
{ bx:=xgm/2*(1-zoom);
 ax:=(xgm/2-bx)*2/iimax;
 ay:=ax;by:=(ygm/2-ay*jjmax/2);}
 ax:=ygm*zoom/imax;
 ay:=-ax;
 bx:=0.5*(xgm-zoom*ygm);
 by:=0.5*ygm*(1+zoom);
 if lgif and (igif=2) then by:=by-ytop;
end;

procedure updateatr;{update transformation matrix for rotation}
var cc:array[1..3,1..3] of real;
i,j,ii:integer;
begin
 for i:=1 to 3 do begin
  for j:=1 to 3 do begin
   cc[i,j]:=0;
   for ii:=1 to 3 do  cc[i,j]:=cc[i,j]+bb[i,ii]*atr[ii,j]
  end;
 end;
 for i:=1 to 3 do for j:=1 to 3 do atr[i,j]:=cc[i,j];
end;

procedure assignww(xa,ya,za,xb,yb,zb,xc,yc,zc,xd,yd,zd,xe,ye,ze,xf,yf,zf,xg,yg,zg,xh,yh,zh,
                   a       ,       b,       c,       d,       e,       f,       g,       h,
                   xx,yy,zz,dx,dy,dz:single;var w:single);
var xt,yt,zt:real;
begin
          if sqr(xa-xx)+sqr(ya-yy)+sqr(za-zz)<0.0001 then  w:=a else begin
           if sqr(xb-xx)+sqr(yb-yy)+sqr(zb-zz)<0.0001 then  w:=b else begin
            if sqr(xc-xx)+sqr(yc-yy)+sqr(zc-zz)<0.0001 then  w:=c else begin
             if sqr(xd-xx)+sqr(yd-yy)+sqr(zd-zz)<0.0001 then  w:=d else begin
              if sqr(xe-xx)+sqr(ye-yy)+sqr(ze-zz)<0.0001 then  w:=e else begin
               if sqr(xf-xx)+sqr(yf-yy)+sqr(zf-zz)<0.0001 then  w:=f else begin
                if sqr(xg-xx)+sqr(yg-yy)+sqr(zg-zz)<0.0001 then  w:=g else begin
                 if sqr(xh-xx)+sqr(yh-yy)+sqr(zh-zz)<0.0001 then  w:=h else begin
                  xt:=xx-xa+dx/2;yt:=yy-ya+dy/2;zt:=zz-za+dz/2;
                  w:=(a+b+c+d+e+f+g+h)/8
                  +(a+b+c+d-e-f-g-h)/dx/4*xt
                  +(a+b-c-d+e+f-g-h)/dy/4*yt
                  +(a-b+c-d+e-f-g+h)/dz/4*zt
                  +(a+b-c-d-e-f+g+h)*xt*yt/dx/dy/2
                  +(a-b+c-d-e+f+g-h)*xt*zt/dx/dz/2
                  +(a-b-c+d+e-f+g-h)*yt*zt/dy/dz/2
                  +(a-b-c+d-e+f-g+h)*xt*yt*zt/dx/dy/dz;
                 end;
                end;
               end;
              end;
             end;
            end;
           end;
          end;
end;

{procedure  drawplanethrough;procedure  drawplanethrough;procedure  drawplanethrough;}

procedure  drawplanethrough(vy,vz:array of single);
const mxtile=200;{maximum number of tiles in one elementary square}
var nro1,nro,nro2,ip,jp,nrac,ii,jj,i,j,k,nc,iproc,iprocold,
iomit,ncp,ncm,nline,j1,i1,i2,ia,ib,iaa,ibb,nintpl:integer;
np:longint;
afreq,ixa,ixb,ixc,ixd,iya,iyb,iyc,iyd,icu,x1,x2,y1,y2,xs,ys:integer;
v,ax,ay,az,p1,p2,p3:vector;
del,rop,rom,tx,ty,tz,a,b,c,d,e,f,g,h,a_f,b_f,c_f,d_f,e_f,f_f,g_f,h_f,
a_y,b_y,c_y,d_y,e_y,f_y,g_y,h_y,a_x,b_x,c_x,d_x,e_x,f_x,g_x,h_x,
vmax,vv,vvx,vvy,beta,gamma,vl,delta:single;
xa,xb,xc,xd,xe,xf,xg,xh,
ya,yb,yc,yd,ye,yf,yg,yh,
za,zb,zc,zd,ze,zf,zg,zh,
w,w_f,pr,vx:double;
potstep,ro0,adx,ady,ax2,ay2,v0,fc,fx,fy,fz,fxy,fxz,fyz,fxyz,xt,yt,zt,
ro_f,v0_f,fx_f,fy_f,fxy_f,ro0_f,percent,tipangle,vscale,
ro,offx,offy,ap,at,am,xx,yy,zz,adist,dist0,dxp,x,y,z:single;
ts:string;
lpot:boolean;
paper:tcanvas;
tlx1,tlx2,tly1,tly2:array[1..mxtile] of smallint;
tro:array[1..mxtile] of real;
cc:tcolor;
bij,bij_f,bij_y,bij_x:array[1..2,0..nmax,0..nmax] of single;
bj,bj_f,bj_y,bj_x:array[1..2,0..nmax] of single;
amr,amv,amy,amx:array of array of single;

procedure addline(var x1,y1,x2,y2:integer);
var i:smallint;
begin
 for i:=1 to nline do begin
  if    ((tlx1[i]=x1)and(tly1[i]=y1)and(tlx2[i]=x2)and(tly2[i]=y2))
     or ((tlx2[i]=x1)and(tly2[i]=y1)and(tlx1[i]=x2)and(tly1[i]=y2)) then exit;
 end;
 if nline=mxtile then exit;
 nline:=nline+1;
 tro[nline]:=ro;
 tlx1[nline]:=x1;tly1[nline]:=y1;tlx2[nline]:=x2;tly2[nline]:=y2;
end;

procedure plotatoms2(var f:file);{projection on a plane}
var noa:longint;r:array of array of double;
    q:array of double;
    z:array of integer;
    ix1,iy1,ix2,iy2,x1,x2,y1,y2:integer;
    l,ll,i:integer;
    xl,yl,zl,xll,yll,zll:real;
    paper:tcanvas;
begin
{Loadatoms}
 blockread(f,noa,4);
 setlength(r,4,noa+1);  setlength(q,noa+1); setlength(z,noa+1);
 for l:=1 to noa do begin
  for i:=1 to 3 do blockread(f,r[i,l],8);
  r[1,l]:=x0+r[1,l];
  r[2,l]:=y0+r[2,l];
  r[3,l]:=z0+r[3,l];
 end;
 for l:=1 to noa do begin   blockread(f,q[l],8);z[l]:=round(q[l]);end;
 if lprint then paper:=printer.canvas   else    paper:=bitmap.canvas;
 with paper do begin
  if lprint then pen.width:=2;
  pen.style:=pssolid;
  pen.color:=clblack;
  pen.width:=strtoint(form7.Edit17.Text);
  for l:=1 to noa do begin
   for ll:=l+1 to noa do begin
    {bonding is in A, r and P in aus}
    if sqr(r[1,l]-r[1,ll])+sqr(r[2,l]-r[2,ll])+sqr(r[3,l]-r[3,ll])<sqr((bonding[z[ll]]+bonding[z[l]])/bohr) then begin
     xll:=r[1,ll]-p1[1];yll:=r[2,ll]-p1[2];zll:=r[3,ll]-p1[3];
     xl :=r[1,l]-p1[1] ;yl :=r[2,l] -p1[2];zl :=r[3,l] -p1[3];
     t2((ax[1]*xl+ax[2]*yl+ax[3]*zl)/dxp,(ay[1]*xl+ay[2]*yl+ay[3]*zl)/dxp,ix1,iy1);
     x1:=ix1+shiftx;
     y1:=iy1+shifty;
     t2((ax[1]*xll+ax[2]*yll+ax[3]*zll)/dxp,(ay[1]*xll+ay[2]*yll+ay[3]*zll)/dxp,ix2,iy2);
     x2:=ix2+shiftx;
     y2:=iy2+shifty;
     if plotter then begin
      writeln(fhgl,'PU'+inttostr(x1)+','+inttostr(y1)+';');
      writeln(fhgl,'PD'+inttostr(x2)+','+inttostr(y2)+';');
      writeln(fhgl,'PU;');
     end else ln(x1,y1,x2,y2);
    end;
   end;
  end;
  pen.width:=1;
 end;
end;

begin

 with form7 do begin
  vscale:=strtofloat(edit22.text);
  percent:=strtofloat(edit21.text);
  tipangle:=strtofloat(edit20.text);
  afreq:=strtoint(Edit19.Text);
  dxp:=strtofloat(edit11.text);  dxp:=dxp/bohr;{grid spacing given in A, now in aus}
  offx:=strtofloat(edit10.text);offy:=strtofloat(edit12.text);
  offx:=offx/bohr;offy:=offy/bohr;
  lpot:=radiobutton2.checked;potstep:=strtofloat(edit13.text);
  if radiogroup1.itemindex=0 then begin {three points in the plane, input in A:}
   p1[1]:=strtofloat(edit1.text);p1[2]:=strtofloat(edit9.text);p1[3]:=strtofloat(edit8.text);
   p2[1]:=strtofloat(edit2.text);p2[2]:=strtofloat(edit6.text);p2[3]:=strtofloat(edit7.text);
   p3[1]:=strtofloat(edit3.text);p3[2]:=strtofloat(edit4.text);p3[3]:=strtofloat(edit5.text);
   for i:=1 to 3 do begin p1[i]:=p1[i]/bohr;p2[i]:=p2[i]/bohr;p3[i]:=p3[i]/bohr;end;{converted in aus}
  end else begin {three atoms, coordinates already from cube beginning, in au}
   for i:=1 to 3 do begin p1[i]:=ratoms[i,iat1];p2[i]:=ratoms[i,iat2];p3[i]:=ratoms[i,iat3];end;
  end;
  nintpl:=strtoint(form7.Edit23.Text);
 end;
 
 setlength(amr,nintpl+1,nintpl+1); setlength(amv,nintpl+1,nintpl+1);
 setlength(amx,nintpl+1,nintpl+1); setlength(amy,nintpl+1,nintpl+1);

 b:=0;b_f:=0;
 dist0:=sqrt(sqr(dx)+sqr(dy)+sqr(dz));
 nrac:=trunc(dist0/dxp)+1;
 for i:=0 to nintpl do for j:=0 to nintpl do begin
  amr[i,j]:=0;amv[i,j]:=-999999.9;amx[i,j]:=0;amy[i,j]:=0;
 end;
 {rectangular axes in the plane:}
 for i:=1 to 3 do ax[i]:=p2[i]-p1[i];norm(ax);for i:=1 to 3 do ay[i]:=p3[i]-p1[i];
 vp(ax,ay,az);norm(az);vp(az,ax,ay);norm(ay);
 for i:=1 to 3 do p1[i]:=p1[i]+offx*ax[i]+offy*ay[i];
 {go through all cubes}
 iaa:=1;ibb:=2;ia:=1;ib:=2;
 nc:=0;iprocold:=0;np:=(i0+1)*(j0+1)*(k0+1);
 x:=x0-dx;iimax:=0;jjmax:=0;iimin:=nintpl;jjmin:=nintpl;
 for i:=0 to i0 do begin
  x:=x+dx;y:=y0-dy;v[1]:=x-p1[1];
  for j:=0 to j0 do begin
   y:=y+dy;z:=z0-dz;v[2]:=y-p1[2];
   for k:=0 to k0 do begin
    z:=z+dz;v[3]:=z-p1[3];
    nc:=nc+1;iproc:=(100*nc) div np;
    if iproc>=iprocold+1 then begin
     str(iproc,ts);form4.caption:=ts+' % completed';
     if lprint then form2.button3.caption:=ts+' %';
     form2.button3.visible:=true;
     iprocold:=iproc;
    end;
    blockread(filt,a,4);if nd=4 then blockread(filt,a_f,4) else a_f:=0;
    if (i>0)and(j>0)and(k>0)then begin{========================================}
    if(form1.checkbox2.Checked)then begin
     vx:=a;
     a_x:=vx*ax[1]+vy[nc]*ax[2]+vz[nc]*ax[3];
     a_y:=vx*ay[1]+vy[nc]*ay[2]+vz[nc]*ay[3];
     a:=sqrt(sqr(a_x)+sqr(a_y));
    end;
    {distance from the plane, vector v to the center of the cube:}
    adist:=abs(dp(v,az));
    if adist<=dist0 then begin {this point is close to the plane}
     c  :=bj  [ib,k];d  :=bj  [ib,k-1];e  :=bij  [ibb,j,k];f  :=bij  [ibb,j,k-1];g  :=bij  [ibb,j-1,k-1];h  :=bij  [ibb,j-1,k];
     c_f:=bj_f[ib,k];d_f:=bj_f[ib,k-1];e_f:=bij_f[ibb,j,k];f_f:=bij_f[ibb,j,k-1];g_f:=bij_f[ibb,j-1,k-1];h_f:=bij_f[ibb,j-1,k];
     c_x:=bj_x[ib,k];d_x:=bj_x[ib,k-1];e_x:=bij_x[ibb,j,k];f_x:=bij_x[ibb,j,k-1];g_x:=bij_x[ibb,j-1,k-1];h_x:=bij_x[ibb,j-1,k];
     c_y:=bj_y[ib,k];d_y:=bj_y[ib,k-1];e_y:=bij_y[ibb,j,k];f_y:=bij_y[ibb,j,k-1];g_y:=bij_y[ibb,j-1,k-1];h_y:=bij_y[ibb,j-1,k];

     ip:=trunc(dp(v,ax)/dxp);{the point is above square (ip,ip+1)x{jp,jp+1)}
     jp:=trunc(dp(v,ay)/dxp);
     xa:=x   ;ya:=y   ;za:=z   ;  xb:=x   ;yb:=y   ;zb:=z-dz;
     xc:=x   ;yc:=y-dy;zc:=z   ;  xd:=x   ;yd:=y-dy;zd:=z-dz;
     xe:=x-dx;ye:=y   ;ze:=z   ;  xf:=x-dx;yf:=y   ;zf:=z-dz;
     xg:=x-dx;yg:=y-dy;zg:=z-dz;  xh:=x-dx;yh:=y-dy;zh:=z   ;
     for ii:=ip-nrac to ip+nrac do begin {investigate the points around}
      if(ii>=0)and(ii<=nintpl)then begin
       for jj:=jp-nrac to jp+nrac do begin
        if (jj>=0)and(jj<=nintpl)then begin
         xx:=p1[1]+(ax[1]*ii+ay[1]*jj)*dxp;
         yy:=p1[2]+(ax[2]*ii+ay[2]*jj)*dxp;
         zz:=p1[3]+(ax[3]*ii+ay[3]*jj)*dxp;
         if(xx>=xg)and(xx<=xd)and(yy>=yd)and(yy<=ya)and(zz>=zd)and(zz<=za)
         and(amv[ii,jj]<-999999.0)then begin
          {this point is in the cube ijk and was not assigned yet}
          if ii>iimax then iimax:=ii;if ii<iimin then iimin:=ii;
          if jj>jjmax then jjmax:=jj;if jj<jjmin then jjmin:=jj;
          {density, or velocity magnitude:}
          assignww(xa,ya,za,xb,yb,zb,xc,yc,zc,xd,yd,zd,xe,ye,ze,xf,yf,zf,xg,yg,zg,xh,yh,zh,
                   a       ,       b,       c,       d,       e,       f,       g,       h,
                   xx,yy,zz,dx,dy,dz,amr[ii,jj]);
          {potential:}
          assignww(xa,ya,za,xb,yb,zb,xc,yc,zc,xd,yd,zd,xe,ye,ze,xf,yf,zf,xg,yg,zg,xh,yh,zh,
                   a_f     ,     b_f,      c_f,     d_f,     e_f,     f_f,     g_f,     h_f,
                   xx,yy,zz,dx,dy,dz,amv[ii,jj]);
          {x-projection in the plane}
          assignww(xa,ya,za,xb,yb,zb,xc,yc,zc,xd,yd,zd,xe,ye,ze,xf,yf,zf,xg,yg,zg,xh,yh,zh,
                   a_x     ,     b_x,      c_x,     d_x,     e_x,     f_x,     g_x,     h_x,
                   xx,yy,zz,dx,dy,dz,amx[ii,jj]);
          {y-projection in the plane}
          assignww(xa,ya,za,xb,yb,zb,xc,yc,zc,xd,yd,zd,xe,ye,ze,xf,yf,zf,xg,yg,zg,xh,yh,zh,
                   a_y     ,     b_y,      c_y,    d_y,     e_y,     f_y,     g_y,     h_y,
                   xx,yy,zz,dx,dy,dz,amy[ii,jj]);
          {this point was inside the cube}
         end;
        end;
       end;{jj}
      end;
     end;{ii}
    end;{if -close to the plane};
    end;{====================================================================}
    {density or potential alone or velocity magnitude:}
    b  :=a  ;bij  [iaa,j,k]:=a  ;bj  [ia,k]:=a  ;
    {potential:}
    b_f:=a_f;bij_f[iaa,j,k]:=a_f;bj_f[ia,k]:=a_f;
    {x-v projection:}
    b_x:=a_x;bij_x[iaa,j,k]:=a_x;bj_x[ia,k]:=a_x;
    {y-v projection:}
    b_y:=a_y;bij_y[iaa,j,k]:=a_y;bj_y[ia,k]:=a_y;
   end;{k}
   si(ia,ib);
  end;{j}
  si(iaa,ibb);
 end;{i}

 {zero-out unassigned points}
 for i:=0 to nintpl do for j:=0 to nintpl do begin
  if amv[i,j]<-999999.0 then amv[i,j]:=0;
 end;

 {get rid of useless points}
 for i:=iimin to iimax do for j:=jjmin to jjmax do begin
  amv[i-iimin,j]:=amv[i,j];
  amr[i-iimin,j]:=amr[i,j];
  amx[i-iimin,j]:=amx[i,j];
  amy[i-iimin,j]:=amy[i,j];
 end;
 iimax:=iimax-iimin;if iimax<1 then iimax:=1;
 for j:=jjmin to jjmax do for i:=0 to iimax do begin
  amv[i,j-jjmin]:=amv[i,j];
  amr[i,j-jjmin]:=amr[i,j];
  amx[i,j-jjmin]:=amx[i,j];
  amy[i,j-jjmin]:=amy[i,j];
 end;
 jjmax:=jjmax-jjmin;if jjmax<1 then jjmax:=1;

 setscale2;
 if lprint then paper:=printer.canvas else paper:=bitmap.canvas;

 with paper do begin
 if form2.chb4.checked then begin {paint area}
  for j:=1 to jjmax do begin
   form4.caption:='plotting '+inttostr(j)+'of '+inttostr(jjmax);
   for i:=1 to iimax do begin
    t2(i,j,ixa,iya);ixd:=ixa;iyb:=iya;t2(i-1,j-1,ixc,iyc);iyd:=iyc;ixb:=ixc;
    adx:=ixa-ixb;ady:=iya-iyc;ax2:=(ixa+ixb)/2;ay2:=(iyc+iya)/2;
    a_f:=amv[i,j];b_f:=amv[i-1,j];c_f:=amv[i-1,j-1];d_f:=amv[i,j-1];
    a  :=amr[i,j];b:=amr[i-1,j];  c:=amr[i-1,j-1];  d:=amr[i,j-1];
    v0:=0.25*(a+b+c+d);v0_f:=0.25*(a_f+b_f+c_f+d_f);
    if ixa=ixb then begin fx:=0;fx_f:=0 end else begin
     fx:=0.5*(a-b+d-c)/adx;fx_f:=0.5*(a_f-b_f+d_f-c_f)/adx;
    end;
    if iyc=iya then begin fy_f:=0;fy:=0 end else begin
     fy:=0.5*(a+b-d-c)/ady;fy_f:=0.5*(a_f+b_f-d_f-c_f)/ady;
    end;
    if (ixa=ixb)or(iyc=iya)then begin fxy:=0;fxy_f:=0 end else begin
     fxy:=(a+c-b-d)/(adx*ady);fxy_f:=(a_f+c_f-b_f-d_f)/(adx*ady);
    end;
    for ii:=ixb to ixa do begin
     x:=(ii-ax2);ro0:=v0+fx*x;ro0_f:=v0_f+fx_f*x;
     for jj:=iya to iyc do begin
      ro:=ro0+(fy+fxy*x)*(jj-ay2);ro_f:=ro0_f+(fy_f+fxy_f*x)*(jj-ay2);
      if ro<ros then begin
       if lpot then scpp(cc,pmax,pmin,ro_f) else scpp(cc,pmax,pmin,ro);
       if lprint and not(form7.checkbox2.checked) then begin
        pen.color:=cc;
        rectangle(ii+shiftx,jj+shifty,ii+2+shiftx,jj+2+shifty);
       end else pixels[ii+shiftx,jj+shifty]:=cc;
      end;
     end;
    end;
   end;{i}
  end;{j}
 end;{paint area}

 {draw arrows}
 if form1.CheckBox2.Checked then begin
  pen.color:=clblack;
  vmax:=0;
  for i:=1 to nintpl do begin
   for j:=1 to nintpl do begin
    vv:=amr[i,j];if vv>vmax then vmax:=vv;
   end;
  end;

  if (vmax<>0)then begin
                                                                 {               ->>              }
  for i:=0 to iimax do begin if i mod afreq = 0 then begin      {                 ->>            }
   for j:=0 to jjmax do begin  if j mod afreq = 0 then begin    {     ============= ->>          }
    vvx:=amx[i,j];vvy:=amy[i,j];                                 {     =============== ->>        }
    t2(i,j,ixa,iya);                                             {     ============= ->>          }
    xx:=vvx/vmax*vscale*10;yy:=vvy/vmax*vscale*10;               {                 ->>            }
    xs :=ixa-round(0.5*xx);ys :=iya-round(0.5*yy);               {               ->>              }
    ixb:=xs +round(    xx);iyb:=ys +round(    yy);
    moveto(xs+shiftx,ys+shifty);lineto(ixb+shiftx,iyb+shifty);
    vl:=percent*sqrt(sqr(xx)+sqr(yy))/100;
    beta:=180/pi*arctan2(vvy,vvx);
    gamma:=(90-beta-tipangle)*pi/180;
    x1:=ixb-round(vl*sin(gamma));
    y1:=iyb-round(vl*cos(gamma));
    moveto(ixb+shiftx,iyb+shifty);lineto(x1+shiftx,y1+shifty);
    delta:=(beta-tipangle)*pi/180;
    x2:=ixb-round(vl*cos(delta));
    y2:=iyb-round(vl*sin(delta));
    moveto(ixb+shiftx,iyb+shifty);lineto(x2+shiftx,y2+shifty);
   end;end;
  end;end;

  end;

 end;

 if not(form2.chb4.checked) or form7.checkbox1.checked then begin {line}
  if lpot then del:=potstep else del:=ros;
  for j:=0 to jjmax do begin
   form4.caption:='plotting '+inttostr(j)+'of '+inttostr(jjmax);
   for i:=0 to iimax do begin
    if (j>0) and (i>0) then begin
     if lpot then begin
      a:=amv[i,j];b:=amv[i-1,j];c:=amv[i-1,j-1];d:=amv[i,j-1];
     end else begin
      a:=amr[i,j];b:=amr[i-1,j];c:=amr[i-1,j-1];d:=amr[i,j-1];
     end;
     {plot the square       nline ... number of lines}
     nline:=0;

    {AB line}
    setp(nro1,nro2,a,b,del);iomit:=(nro2-nro1)div (mxtile div 3)+1;nro:=nro1-1;
    repeat nro:=nro+1;if(nro div iomit)*iomit=nro then begin ro:=del*nro;
     if fb(a,b,ro) and fb(cop,com,ro) then begin
      icu:=0;t2(i-1+(ro-b)/(a-b),j,x1,y1);
      if fb(a,d,ro) then begin
       t2(i,j-1+(ro-d)/(a-d),x2,y2);icu:=icu+1;addline(x1,y1,x2,y2);
      end;
      if fb(c,d,ro) then begin
       t2(i-1+(ro-c)/(d-c),j-1,x2,y2);
       icu:=icu+1;if icu<2 then addline(x1,y1,x2,y2);
      end;
      if fb(c,b,ro) then begin
       t2(i-1,j-1+(ro-c)/(b-c),x2,y2);
       icu:=icu+1;if icu<2 then addline(x1,y1,x2,y2);
      end;
     end;{if ro within AB}
    end;until nro=nro2;{nro loop}

    {AD line}
    setp(nro1,nro2,a,d,del);iomit:=(nro2-nro1)div (mxtile div 3)+1;nro:=nro1-1;
    repeat nro:=nro+1;if(nro div iomit)*iomit=nro then begin ro:=del*nro;
     if fb(a,d,ro)and fb(cop,com,ro) then begin
      icu:=0;t2(i,j-1+(ro-d)/(a-d),x1,y1);
      if fb(c,d,ro) then begin
       t2(i-1+(ro-c)/(d-c),j-1,x2,y2);icu:=icu+1;addline(x1,y1,x2,y2);
      end;
      if fb(c,b,ro) then begin
       t2(i-1,j-1+(ro-c)/(b-c),x2,y2);
       icu:=icu+1;if icu<2 then addline(x1,y1,x2,y2);
      end;
     end;{if ro within AD}
    end;until nro=nro2;{nro loop}

    {CD line}
    setp(nro1,nro2,c,d,del);iomit:=(nro2-nro1)div (mxtile div 3)+1;nro:=nro1-1;
    repeat nro:=nro+1;if(nro div iomit)*iomit=nro then begin ro:=del*nro;
     if fb(c,d,ro) and fb(cop,com,ro) then begin
      t2(i-1+(ro-c)/(d-c),j-1,x1,y1);
      if fb(c,b,ro) then begin
       t2(i-1,j-1+(ro-c)/(b-c),x2,y2);addline(x1,y1,x2,y2);
      end;
     end;{if ro within CD}
    end;until nro=nro2;{nro loop}

    for ii:=1 to nline do begin ro:=tro[ii];
     if lpot then begin
      if form7.checkbox1.checked then cc:=clblack else scpp(cc,pmax,pmin,ro);
      pen.color:=cc;
     end else begin
      if ro<0 then pen.color:=clblue else pen.color:=clred;
      if baw and (ro<0) then pen.style:=psdot else pen.style:=pssolid;
      if baw or (ro=0) then pen.color:=clblack;
     end;
     pen.Width:=strtoint(form7.edit18.Text);
     ln(tlx1[ii]+shiftx,tly1[ii]+shifty,tlx2[ii]+shiftx,tly2[ii]+shifty);
    end;
   end;{i and j>0}
  end;{i}
 end;{j}
end;{paint area}
end;{with paper/canvas}

form4.caption:=name;
if form2.checkbox5.checked then esscale;
if form7.checkbox3.checked then plotatoms2(filt);
closefile(filt);
end;

{END procedure  drawplanethrough;procedure  drawplanethrough;procedure  drawplanethrough;}

procedure  quicksort(n:integer;var arr:array of cl);
label l1,l2,l3,l4,l5;
const NSTACK=numberofcubes;M=10;
var a,temp:cl;
i,j,ir,jstack,k,l:integer;
istack:array[1..NSTACK] of integer;
begin
 jstack:=0;
 l:=1;
 ir:=n;
 l1:
 if ir-l<M then begin
  for j:=l+1 to ir do begin
   a:=arr[j];
   for i:=j-1 downto l do begin
    if arr[i].z<=a.z then  goto l2;
    arr[i+1]:=arr[i];
   end;
   i:=l-1;
   l2:
   arr[i+1]:=a;
  end;
  if jstack=0 then exit;
  ir:=istack[jstack];
  l:=istack[jstack-1];
  jstack:=jstack-2
 end else begin
  k:=(l+ir) div 2;
  temp:=arr[k];arr[k]:=arr[l+1];arr[l+1]:=temp;
  if arr[l].z>arr[ir].z then begin
   temp:=arr[l];arr[l]:=arr[ir];arr[ir]:=temp;
  end;
  if arr[l+1].z>arr[ir].z then begin
   temp:=arr[l+1];arr[l+1]:=arr[ir];arr[ir]:=temp;
  end;
  if arr[l].z>arr[l+1].z then begin
   temp:=arr[l];arr[l]:=arr[l+1];arr[l+1]:=temp;
  end;
  i:=l+1;
  j:=ir;
  a:=arr[l+1];
  l3:i:=i+1;if arr[i].z<a.z then goto l3;
  l4:j:=j-1;if arr[j].z>a.z then goto l4;
  if j<i then goto l5;
  temp:=arr[i];arr[i]:=arr[j];arr[j]:=temp;
  goto l3;
  l5:
  arr[l+1]:=arr[j];
  arr[j]:=a;
  jstack:=jstack+2;
  if jstack>nstack then begin
   showmessage('nstack too small');
   exit;
  end;
  if ir-i+1>=j-l then begin
   istack[jstack]:=ir;
   istack[jstack-1]:=i;
   ir:=j-1;
  end else begin
   istack[jstack]:=j-1;
   istack[jstack-1]:=l;
   l:=i;
  end;
 end;
 goto l1;
end;

procedure readpfile(s:string;var v:array of single);
var i,j,k,nc:integer;
    filt:file;
begin
assign(filt,s);
reset(filt,1);{recsize:=1;}
blockread(filt,name,82);
blockread(filt,nd,2);
blockread(filt,i0,2);blockread(filt,j0,2);blockread(filt,k0,2);
blockread(filt,x0,4);blockread(filt,y0,4);blockread(filt,z0,4);
blockread(filt,dx,4);blockread(filt,dy,4);blockread(filt,dz,4);
nc:=0;
for i:=0 to i0 do begin
 for j:=0 to j0 do begin
  for k:=0 to k0 do begin
   nc:=nc+1;
   blockread(filt,v[nc],4);
  end;
 end;
end;
closefile(filt);
end;

procedure readppp(nd:integer);
label l1,l2,l3,l4;
var
    nro1,nro2,ia,nro,iaa,ibb,nrod,nroc,nrob,
    item,ii,ib,i,j,k,l,m,n,x1,x2,y1,y2,ic,im,nshade,nde:integer;
    nline,imin,icu,icut,i0,j0,k0:smallint;
    noc,newt,nc,np,iproc,iprocold:longint;
    lti,oldx,oldy:array[1..nuco]of smallint;
    oldtcl:array[1..nuco]of tcolor;
    oldpot:array[1..nuco]of single;
    oldbt:array[1..nuco,1..2] of byte;
    edges:array[1..nuco,1..nuco] of smallint;
{    x,y:real;}
    t,ts:string;
    ff:array[0..nmax] of real;
    zmin,fi,a,b,c,d,e,f,g,h,ro,a_f,b_f,c_f,d_f,e_f,f_f,g_f,h_f:single;
    paper:tcanvas;
    used:array[1..nuco] of boolean;
    pcolor,iblue,igreen,ired:tcolor;
    bj,bj_f:array[1..2,0..nmax] of single;
    bij,bij_f:array[1..2,0..nmax,0..nmax] of single;
    vz,vy:array of single;

begin
val(form2.edit13.text,pmin,i);val(form2.edit12.text,pmax,i);  {potential limits}
pmin:=pmin/ha;pmax:=pmax/ha;
hideback:=false;
baw:=not(form2.checkbox4.checked);
lshade:=form2.checkbox2.checked;
val(form2.edit11.text,nshade,im);

if plotter then writeln(fhgl,'SP1;');
if lprint or plotter then begin
 xgm:=printer.pagewidth;
 ygm:=printer.pageheight;
 paper:=printer.canvas;
end else begin
 paper:=bitmap.canvas;
 if lgif and (igif=2)then begin
  xgm:=gwidth;ygm:=gheight;
 end else begin
  xgm:=bitmap.width;ygm:=bitmap.height;
 end;
end;
val(form2.edit9.text,shiftx,im);shiftx:=round(shiftx/100.0*xgm);
val(form2.edit10.text,shifty,im);shifty:=round(shifty/100.0*ygm);
centerx:=shiftx+xgm div 2;
centery:=shifty+ygm div 2;


{2222222222222222222222222222222222222222222222222222222222222222222222}
if nd=2 then begin
 assignfile(filt,'den.ppp');reset(filt,1);{recsize:=1;}
 blockread(filt,name,82);
 blockread(filt,nd,2);
 form4.caption:='two dimensional';
 blockread(filt,item,2);i0:=item;{item is integer*2,i0 is integer*4}
 if i0>nmax then begin
  MessageDlg('i0='+inttostr(i0)+' Too many grid points, limit='+inttostr(nmax)+'!',mtinformation,[mbOK],0);
  closefile(filt); form4.close;exit;
 end;
 b:=0;
 blockread(filt,item,2);j0:=item;

 bx:=xgm div 2 - (ygm/xgm)*(xgm div 2);
 ax:=(ygm/xgm)*(xgm)/i0;
 ay:=-ygm/i0;
 by:=ygm;
 if lgif and (igif=2) then by:=by-ytop;

 blockread(filt,x0,4);blockread(filt,y0,4);
 blockread(filt,dx,4);blockread(filt,dx,4);

 with paper do begin
  ia:=1;ib:=2;
  for j:=0 to j0 do begin
   form4.caption:=inttostr(j)+'of '+inttostr(j0);
   si(ia,ib);
   for i:=0 to i0 do begin
    blockread(filt,a,4);
    if (j>0) and (i>0) then begin
     c:=bj[ib,i-1];d:=bj[ib,i];

     {AB line}
     setp(nro1,nro2,a,b,ros);
     for nro:=nro1 to nro2 do begin ro:=ros*nro;
      if fb(a,b,ro) and fb(cop,com,ro) then begin
       if ro<0 then pen.color:=clblue else pen.color:=clred;
       if baw and (pen.color=clblue) then pen.style:=psdot else pen.style:=pssolid;
       if baw or (ro=0) then pen.color:=clblack;
       icu:=0;
       t2(i-1+(ro-b)/(a-b),j,x1,y1);
       if fb(a,d,ro) then begin
        t2(i,j-1+(ro-d)/(a-d),x2,y2);icu:=icu+1;ln(x1,y1,x2,y2);
       end;
       if fb(c,d,ro) then begin
        t2(i-1+(ro-c)/(d-c),j-1,x2,y2);
        icu:=icu+1;if icu<2 then ln(x1,y1,x2,y2);
       end;
       if fb(c,b,ro) then begin
        t2(i-1,j-1+(ro-c)/(b-c),x2,y2);
        icu:=icu+1;if icu<2 then ln(x1,y1,x2,y2);
       end;
      end;{if ro within AB}
     end;{nro loop}

     {AD line}
     setp(nro1,nro2,a,d,ros);
     for nro:=nro1 to nro2 do begin ro:=ros*nro;
      if fb(a,d,ro)and fb(cop,com,ro) then begin
       icu:=0;
       t2(i,j-1+(ro-d)/(a-d),x1,y1);
       if ro<0 then pen.color:=clblue else pen.color:=clred;
       if baw and (pen.color=clblue) then pen.style:=psdot else pen.style:=pssolid;
       if baw or (ro=0) then pen.color:=clblack;
       if fb(c,d,ro) then begin
        t2(i-1+(ro-c)/(d-c),j-1,x2,y2);icu:=icu+1;ln(x1,y1,x2,y2);
       end;
       if fb(c,b,ro) then begin
        t2(i-1,j-1+(ro-c)/(b-c),x2,y2);
        icu:=icu+1;if icu<2 then ln(x1,y1,x2,y2);
       end;
      end;{if ro within AD}
     end;{nro loop}

     {CD line}
     setp(nro1,nro2,c,d,ros);
     for nro:=nro1 to nro2 do begin ro:=ros*nro;
      if fb(c,d,ro) and fb(cop,com,ro) then begin
       t2(i-1+(ro-c)/(d-c),j-1,x1,y1);
       if fb(c,b,ro) then begin
        if ro<0 then pen.color:=clblue else pen.color:=clred;
        if baw and (pen.color=clblue) then pen.style:=psdot else pen.style:=pssolid;
        if baw or (ro=0) then pen.color:=clblack;
        t2(i-1,j-1+(ro-c)/(b-c),x2,y2);ln(x1,y1,x2,y2);
       end;
      end;{if ro within CD}
     end;{nro loop}

    end;{i and j>0}
    b:=a;bj[ia,i]:=a;
   end;{i}
  end;{j}
 end;{with canvas}
 closefile(filt);
 form4.caption:=name;
end;{for nd=2}
{2222222222222222222222222222222222222222222222222222222222222222222222}

{3333333333333333333333333333333333333333333333333333333333333333333333}
if (nd=3) or (nd=4) then begin
form4.caption:='three dimensional';
hideback:=form2.checkbox3.checked;
if(form1.CheckBox2.checked)then assign(filt,'denx.ppp') else assign(filt,'den.ppp');

reset(filt,1);{recsize:=1;}
blockread(filt,name,82);
blockread(filt,nd,2);
blockread(filt,i0,2);blockread(filt,j0,2);blockread(filt,k0,2);
blockread(filt,x0,4);blockread(filt,y0,4);blockread(filt,z0,4);
blockread(filt,dx,4);blockread(filt,dy,4);blockread(filt,dz,4);
np:=(i0+1)*(j0+1)*(k0+1);

if(form1.CheckBox2.checked)then begin
 setlength(vy,np+1);readpfile('deny.ppp',vy);
 setlength(vz,np+1);readpfile('denz.ppp',vz);
end;

val(form2.edit4.text,fi,ic);{rotation around x}
if fi<>0 then begin
 form2.edit4.text:='0';fi:=fi*Pi/180;
 bb[1,1]:=1;bb[1,2]:= 0;      bb[1,3]:=0;
 bb[2,1]:=0;bb[2,2]:= cos(fi);bb[2,3]:=sin(fi);
 bb[3,1]:=0;bb[3,2]:=-sin(fi);bb[3,3]:=cos(fi);
 updateatr;
end;
val(form2.edit5.text,fi,ic);{rotation around y}
if fi<>0 then begin
 form2.edit5.text:='0';fi:=fi*Pi/180;
 bb[1,1]:= cos(fi) ;bb[1,2]:= 0;      bb[1,3]:=sin(fi);
 bb[2,1]:=0        ;bb[2,2]:= 1;      bb[2,3]:=0;
 bb[3,1]:=-sin(fi);bb[3,2]:=  0;      bb[3,3]:=cos(fi);
 updateatr;
end;
val(form2.edit14.text,fi,ic);{rotation around z}
if fi<>0 then begin
 form2.edit14.text:='0';fi:=fi*Pi/180;
 bb[1,1]:= cos(fi);bb[1,2]:=sin(fi);bb[1,3]:=0;
 bb[2,1]:=-sin(fi);bb[2,2]:=cos(fi);bb[2,3]:=0;
 bb[3,1]:=       0;bb[3,2]:=0;      bb[3,3]:=1;
 updateatr;
end;

bx:=xgm div 2 - (ygm/xgm)*(xgm div 2);
ax:=(ygm/xgm)*xgm/i0;
ay:=-ygm/i0;by:=ygm;
if lgif and (igif=2) then by:=by-ytop;

if (i0>nmax) or (j0>nmax) or (k0>nmax) then begin
 MessageDlg('i0='+inttostr(i0)+' j0='+inttostr(j0)+' k0='+inttostr(k0)+' Too many grid points, limit='+inttostr(nmax)+'!',mtinformation,[mbOK],0);
 closefile(filt); form4.close;exit;
end;
with paper do begin
ia:=1;ib:=2;iaa:=1;ibb:=2;i02:=i0/2;j02:=j0/2;k02:=k0/2;
nc:=0;iprocold:=0;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

if form2.checkbox6.checked then begin  {intersection plane}

 drawplanethrough(vy,vz);
 exit;

end else begin  {++++++++++++++++++++++++++++++++++++++++++++++++++++++++}


if lshade then begin        {shade starts}

randomize;
b:=0;
for i:=0 to i0 do begin
si(iaa,ibb);
for j:=0 to j0 do begin
 si(ia,ib);
 for k:=0 to k0 do begin
  nc:=nc+1;iproc:=(100*nc) div np;
  if iproc>=iprocold+1 then begin
   str(iproc,ts);form4.caption:=ts+' % completed';
   if lprint then form2.button3.caption:=ts+' % completed';
   form2.button3.visible:=true;
   iprocold:=iproc;
  end;
  blockread(filt,a,4);if nd=4 then blockread(filt,a_f,4);
  if (k>0) and (j>0) and (i>0) then begin
   c:= bj[ib ,k-1];d:= bj[ib,k];
   e:=bij[ibb,k  ,j  ];f:=bij[ibb,k-1,j  ];
   g:=bij[ibb,k-1,j-1];h:=bij[ibb,k  ,j-1];
   ro:=(a+b+c+d+e+f+g+h)*0.125;
   if ro<0 then pen.color:=clblue else pen.color:=clred;
   if baw then pen.color:=clblack;
   ro:=abs(ro);
   if ro/ros>1.0 then nde:=nshade else nde:=round(ro/ros*nshade);
   for ii:=1 to nde do begin
    t3(i-1.0+random,j-1.0+random,k-1.0+random,x1,y1);pixel(x1,y1);
   end;
  end;{i,j and j>0}
  b:=a;bij[iaa,k,j]:=a;bj[ia,k]:=a;
 end;{k}
end;{j}
end;{i}
plotatoms(filt);

end else begin   {shade ends}

icube:=0;{number of cubes that are painted}
if form2.checkbox7.checked then {make a file for mcm95} begin
 assignfile(ftem,'tem.scr');
 rewrite(ftem,2);
 ntem:=0;
end;

form4.caption:='init';
form4.caption:='befor';
b:=0;
for i:=0 to i0 do begin
si(iaa,ibb);
for j:=0 to j0 do begin
 si(ia,ib);
 for k:=0 to k0 do begin
  nc:=nc+1;iproc:=(100*nc) div np;
  if iproc>=iprocold+1 then begin
   str(iproc,ts);form4.caption:=ts+' % read in';
   iprocold:=iproc;
  end;
  blockread(filt,a,4);if nd=4 then blockread(filt,a_f,4);
  if (k>0) and (j>0) and (i>0) then begin
   c:=bj[ib,k-1];d:=bj[ib,k];e:=bij[ibb,k,j];f:=bij[ibb,k-1,j];
   g:=bij[ibb,k-1,j-1];h:=bij[ibb,k,j-1];
   if nd=4 then begin
    f4:=a_f;
    c_f:=bj_f[ib,k-1];d_f:=bj_f[ib,k];e_f:=bij_f[ibb,k,j];f_f:=bij_f[ibb,k-1,j];
    g_f:=bij_f[ibb,k-1,j-1];h_f:=bij_f[ibb,k,j-1];
    f4:=0.125*(a_f+b_f+c_f+d_f+e_f+f_f+g_f+h_f);
   end;

   for nro:=1 to 2 do begin
    icut:=0;{number of lines painted for this cube}
    if nro=2 then ro:=-ros else ro:=ros;
    if ro<0 then acl:=clblue else acl:=clred;
    if (ro=0) then acl:=clblack;
          {
                 ^
                j|
                 F_______E
                /|       /|
               B_|_____A  |
               | G.....|.H  -> k
               |/      |/
               C_______D
             /
             i}

    {AB line}
    if fb(a,b,ro) then begin icu:=0;t3(i,j,k-1+(ro-b)/(a-b),x1,y1);
     if fb(a,d,ro) then begin t3(i,j-1+(ro-d)/(a-d),k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(c,d,ro) then begin t3(i,j-1,k-1+(ro-c)/(d-c),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(c,b,ro) then begin t3(i,j-1+(ro-c)/(b-c),k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     icu:=0;
     if fb(e,f,ro) then begin t3(i-1,j,k-1+(ro-f)/(e-f),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(e,a,ro) then begin t3(i-1+(ro-e)/(a-e),j,k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(b,f,ro) then begin t3(i-1+(ro-f)/(b-f),j,k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;{if ro within AB}

    {AD line}
    if fb(a,d,ro) then begin icu:=0;t3(i,j-1+(ro-d)/(a-d),k,x1,y1);
     if fb(c,d,ro) then begin t3(i,j-1,k-1+(ro-c)/(d-c),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(c,b,ro) then begin t3(i,j-1+(ro-c)/(b-c),k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     icu:=0;
     if fb(a,e,ro) then begin t3(i-1+(ro-e)/(a-e),j,k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(e,h,ro) then begin t3(i-1,j-1+(ro-h)/(e-h),k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(d,h,ro) then begin t3(i-1+(ro-h)/(d-h),j-1,k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;{if ro within AD}

    {AE line}
    if fb(e,a,ro) then begin  t3(i-1+(ro-e)/(a-e),j,k,x1,y1);
     icu:=0;
     if fb(b,f,ro) then begin t3(i-1+(ro-f)/(b-f),j,k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(e,f,ro) then begin t3(i-1,j,k-1+(ro-f)/(e-f),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     icu:=0;
     if fb(e,h,ro) then begin t3(i-1,j-1+(ro-h)/(e-h),k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(d,h,ro) then begin t3(i-1+(ro-h)/(d-h),j-1,k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;{AE}

    {CD - DH,CB lines}
    if fb(c,d,ro) then begin t3(i,j-1,k-1+(ro-c)/(d-c),x1,y1);
     if fb(d,h,ro) then begin t3(i-1+(ro-h)/(d-h),j-1,k,x2,y2);
      icu:=0;seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(c,b,ro) then begin t3(i,j-1+(ro-c)/(b-c),k-1,x2,y2);
      icu:=0;seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;

    {FE,BC - BF line}
    if fb(b,f,ro) then begin t3(i-1+(ro-f)/(b-f),j,k-1,x1,y1);
     if fb(e,f,ro) then begin icu:=0;t3(i-1,j,k-1+(ro-f)/(e-f),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(b,c,ro) then begin icu:=0;t3(i,j-1+(ro-c)/(b-c),k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;

    {FE,HD - EH line}
    if fb(e,h,ro) then begin t3(i-1,j-1+(ro-h)/(e-h),k,x1,y1);
     if fb(d,h,ro)then begin t3(i-1+(ro-h)/(d-h),j-1,k,x2,y2);
      icu:=0;seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(e,f,ro) then begin icu:=0;t3(i-1,j,k-1+(ro-f)/(e-f),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;

    {GH line}
    if fb(g,h,ro) then begin t3(i-1,j-1,k-1+(ro-g)/(h-g),x1,y1);
     icu:=0;
     if fb(g,f,ro) then begin t3(i-1,j-1+(ro-g)/(f-g),k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(e,f,ro) then begin t3(i-1,j,k-1+(ro-f)/(e-f),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(e,h,ro) then begin t3(i-1,j-1+(ro-h)/(e-h),k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     icu:=0;
     if fb(c,d,ro) then begin t3(i,j-1,k-1+(ro-c)/(d-c),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(h,d,ro) then begin t3(i-1+(ro-h)/(d-h),j-1,k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(g,c,ro) then begin t3(i-1+(ro-g)/(c-g),j-1,k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;{if ro within GH}

    {GF line}
    if fb(g,f,ro) then begin t3(i-1,j-1+(ro-g)/(f-g),k-1,x1,y1);icu:=0;
     if fb(e,f,ro) then begin t3(i-1,j,k-1+(ro-f)/(e-f),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(e,h,ro) then begin t3(i-1,j-1+(ro-h)/(e-h),k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     icu:=0;
     if fb(b,f,ro) then begin t3(i-1+(ro-f)/(b-f),j,k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(b,c,ro) then begin t3(i,j-1+(ro-c)/(b-c),k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(c,g,ro) then begin t3(i-1+(ro-g)/(c-g),j-1,k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;{if ro within GF}

    {CG line}
    if fb(c,g,ro) then begin icu:=0;t3(i-1+(ro-g)/(c-g),j-1,k-1,x1,y1);
     if fb(b,f,ro) then begin t3(i-1+(ro-f)/(b-f),j,k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(b,c,ro) then begin t3(i,j-1+(ro-c)/(b-c),k-1,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     icu:=0;
     if fb(c,d,ro) then begin t3(i,j-1,k-1+(ro-c)/(d-c),x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
     if fb(d,h,ro) then begin t3(i-1+(ro-h)/(d-h),j-1,k,x2,y2);
      seecube2(i,j,k,icu,icut,x1,y1,x2,y2);
     end;
    end;{if ro within CG}

    if (icut>0) and form2.checkbox7.checked then {make a file for mcm95} begin
     ntem:=ntem+1;item:=-nro;
     blockwrite(ftem,item,2);blockwrite(ftem,i,2); blockwrite(ftem,j,2); blockwrite(ftem,k,2);
    end;

   end;{nro loop}

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  end;{i,k and j>0}
  b:=a;bij[iaa,k,j]:=a;bj[ia,k]:=a;
  if nd=4 then begin  b_f:=a_f;bij_f[iaa,k,j]:=a_f;bj_f[ia,k]:=a_f;end;
 end;{i}
end;{j}
end;{k}
if form2.checkbox7.checked then {make a file for mcm95} begin
 closefile(ftem);
end;

{devide cubes into tiles}
form4.caption:='sepparating surface tiles ...';
ncube:=icube;
for i:=1 to icube do begin
 with tile[i]do begin
 noc:=corners; if noc>nuco then noc:=nuco;
  for k:=1 to noc do begin
   oldx[k]:=x[k];
   oldy[k]:=y[k];
   oldtcl[k]:=tcl[k];
   oldpot[k]:=potential[k];
   oldbt[k,1]:=bt[k,1];oldbt[k,2]:=bt[k,2];
  end;
  nline:=0;

  for j:=1 to noc do begin

   for k:=1 to nline do begin {is it already part of a tile?}
    for l:=1 to lti[k] do if (edges[k,l]=j) then goto l1;
   end;

   for k:=1 to nline do begin {is it connected to some tile?}
    for l:=1 to lti[k] do begin
     if (oldbt[edges[k,l],1]=j) or (oldbt[edges[k,l],2]=j) then goto l2;
    end;
   end;

   nline:=nline+1;lti[nline]:=1;edges[nline,1]:=j;goto l1;
   l2:lti[k]:=lti[k]+1;edges[k,lti[k]]:=j;
   l1:{next corner}

  end;{j}

  for j:=1 to nline do begin
   if j=1 then begin {write first tile into old cube}
    newt:=i;
   end else begin    {add the rest to the list}
    newt:=ncube+j-1;tile[newt].z:=tile[i].z;
   end;
   tile[newt].corners:=lti[j];
   for l:=1 to lti[j] do used[l]:=false;
   k:=1;m:=0;
   l3:m:=m+1;
   tile[newt].x[m]:=oldx[edges[j,k]];
   tile[newt].y[m]:=oldy[edges[j,k]];
   tile[newt].tcl[m]:=oldtcl[edges[j,k]];
   tile[newt].potential[m]:=oldpot[edges[j,k]];
   used[k]:=true;
   {look for an unused point that is connected to k:}
   for l:=1 to lti[j] do begin
    if (not(used[l])) and ((oldbt[edges[j,k],1]=edges[j,l])
    or(oldbt[edges[j,k],2]=edges[j,l])) then begin k:=l;goto l3; end;
   end;
   {finish unused points:}
   for l:=1 to lti[j] do begin
    if not(used[l]) then begin k:=l;goto l3;end;
   end;

  end;{j}
  ncube:=ncube+nline-1;
  if ncube>numberofcubes then begin
   form2.caption:='too many cubes encountered';form4.close;
  end;

 end;{with tile}
end;{i cube}

{order according to z}
{if hideback then begin
 form4.caption:='ordering '+inttostr(ncube)+'  tiles ...';
 for i:=1 to ncube do begin
  zmin:=tile[i].z;imin:=i;
  for j:=i+1 to ncube do begin
   if tile[j].z<zmin then begin zmin:=tile[j].z;imin:=j;end;
  end;
  if imin<>i then begin
   ttl:=tile[i];tile[i]:=tile[imin];tile[imin]:=ttl;
  end;
 end;
end;}

if hideback then begin
 form4.caption:='ordering '+inttostr(ncube)+'  tiles ...';
 quicksort(ncube,tile);
end;

form4.caption:='painting ...';

if hideback then begin
 brush.style:=bssolid;brush.color:=clwhite;
 for i:=1 to ncube do begin
  pen.color:=tile[i].tcl[1];
  if nd=4 then begin
   f4:=tile[i].potential[1];
   if f4>pmax then f4:=pmax;if f4<pmin then f4:=pmin;
   scpp(pcolor,pmax,pmin,f4);
  end;
  if form2.chb4.checked then begin
   pen.color:=claqua;
   brush.color:=tile[i].tcl[1];
   if nd=4 then begin
    brush.color:=pcolor;
    if baw then pen.color:=clblack;
   end;
   if baw and (nd<>4) then begin
    if (brush.color=clblue) then begin
     pen.color:=clblack;
     brush.style:=bsclear;
     brush.color:=clwhite;
    end else begin
     pen.color:=clwhite;
     brush.color:=clblack;
     brush.style:=bssolid;
     brush.color:=clblack
    end;
   end;
  end else begin
   if baw then begin
    if pen.color=clblue then pen.style:=psdot else pen.style:=pssolid;
    pen.color:=clblack;
   end;
  end;
  for j:=1 to tile[i].corners do begin
   xy[j].x:=tile[i].x[j];  xy[j].y:=tile[i].y[j];
  end;
  if plotter then begin
   writeln(fhgl,'PU'+inttostr(xy[1].x)+','+inttostr(xy[1].y)+';');
   for j:=2 to tile[i].corners do begin
    writeln(fhgl,'PD'+inttostr(xy[j].x)+','+inttostr(xy[j].y)+';');
   end;
   writeln(fhgl,'PD'+inttostr(xy[1].x)+','+inttostr(xy[1].y)+';');
   writeln(fhgl,'PU;');
  end else polygon(slice(xy,tile[i].corners));
 end;

end else begin {not hideback}

 for i:=1 to ncube do begin
  pen.color:=tile[i].tcl[1];
  if baw then begin
   pen.color:=clblack;
   if pen.color=clblue then pen.style:=psdot else pen.style:=pssolid;
  end;
  for j:=1 to tile[i].corners do begin
   xy[j].x:=tile[i].x[j];  xy[j].y:=tile[i].y[j];
  end;
  if plotter then begin
   writeln(fhgl,'PU'+inttostr(xy[1].x)+','+inttostr(xy[1].y)+';');
   for j:=2 to tile[i].corners do begin
    writeln(fhgl,'PD'+inttostr(xy[j].x)+','+inttostr(xy[j].y)+';');
   end;
   writeln(fhgl,'PD'+inttostr(xy[1].x)+','+inttostr(xy[1].y)+';');
   writeln(fhgl,'PU;');
  end else polyline(slice(xy,tile[i].corners));
 end;
end;

plotatoms(filt);


if lgrid then form4.grid(form4);
drawlabels;
end;{shade}

form4.caption:=name;
closefile(filt);

end;{with paper}
end;{for nd=3}
hideback:=false;

{3333333333333333333333333333333333333333333333333333333333333333333333}
if lgrid then form4.grid(form4);
drawlabels;
end; {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
if form2.checkbox5.checked then esscale;
if not(lprint) and not(plotter) then   form4.image1.picture.graphic:=bitmap;
end;

procedure TForm4.FormCreate(Sender: TObject);
var im:integer;
begin
 val(form2.edit1.text,ros,im);
 val(form2.edit3.text,zoom,im);
end;

procedure TForm4.grid(Sender: TObject);
var x1,x2,y1,y2:integer;
begin
 if lprint then with printer.canvas do begin
  t3( 0, 0, 0,x1,y1);t3( 0, 0,k0,x2,y2);ln(x1,y1,x2,y2);
  t3(i0, 0,k0,x1,y1);ln(x1,y1,x2,y2);
  t3(i0, 0, 0,x2,y2);ln(x1,y1,x2,y2);
  t3( 0, 0, 0,x1,y1);ln(x1,y1,x2,y2);
  t3( 0,j0, 0,x2,y2);ln(x1,y1,x2,y2);
  t3(i0,j0, 0,x1,y1);ln(x1,y1,x2,y2);
  t3(i0,j0,k0,x2,y2);ln(x1,y1,x2,y2);
  t3( 0,j0,k0,x1,y1);ln(x1,y1,x2,y2);
  t3( 0,j0, 0,x2,y2);ln(x1,y1,x2,y2);
  t3( 0, 0,k0,x1,y1);t3( 0,j0,k0,x2,y2);ln(x1,y1,x2,y2);
  t3(i0, 0,k0,x1,y1);t3(i0,j0,k0,x2,y2);ln(x1,y1,x2,y2);
  t3(i0, 0, 0,x1,y1);t3(i0,j0, 0,x2,y2);ln(x1,y1,x2,y2);
 end else with bitmap.canvas do begin
  pen.color:=clblack;
  t3( 0, 0, 0,x1,y1);t3( 0, 0,k0,x2,y2);ln(x1,y1,x2,y2);
  t3(i0, 0,k0,x1,y1);ln(x1,y1,x2,y2);
  t3(i0, 0, 0,x2,y2);ln(x1,y1,x2,y2);
  t3( 0, 0, 0,x1,y1);ln(x1,y1,x2,y2);
  t3( 0,j0, 0,x2,y2);ln(x1,y1,x2,y2);
  t3(i0,j0, 0,x1,y1);ln(x1,y1,x2,y2);
  t3(i0,j0,k0,x2,y2);ln(x1,y1,x2,y2);
  t3( 0,j0,k0,x1,y1);ln(x1,y1,x2,y2);
  t3( 0,j0, 0,x2,y2);ln(x1,y1,x2,y2);
  t3( 0, 0,k0,x1,y1);t3( 0,j0,k0,x2,y2);ln(x1,y1,x2,y2);
  t3(i0, 0,k0,x1,y1);t3(i0,j0,k0,x2,y2);ln(x1,y1,x2,y2);
  t3(i0, 0, 0,x1,y1);t3(i0,j0, 0,x2,y2);ln(x1,y1,x2,y2);
 end;
 if not(lprint) then form4.image1.picture.graphic:=bitmap;
end;

procedure TForm4.seekey(Sender: TObject; var Key: Char);
var i:integer;ok:char;
tj:tjpegimage;
tb:tbitmap;
tr:trect;
begin
ok:=key;
i:=ord(ok) ;
if (i=8) or (i=27) then close;
if (ok='p') or (ok='P') then form5.show;
if (ok='s') or (ok='S') then with form4.savedialog1 do begin
 title:='Save the screen as a bitmap:';
 if execute then image1.picture.savetofile(filename);
end;
if (ok='j') or (ok='J') then with form4.savedialog1 do begin
 title:='Save the screen as a JPG file:';
 if execute then begin
  tb:=tbitmap.create;
  tb.width:=form4.image1.width;
  tb.height:=form4.image1.height;
  tr:=rect(0,0,tb.width,tb.height);
  tb.canvas.copyrect(tr,form4.image1.Canvas,tr);
  tj:=tjpegimage.create;
  tj.assign(tb);
  tj.savetofile(filename);
  tj.free;
  tb.free;
 end;
end;
if (ok='l') or (ok='L') then begin
 if(mrYes=MessageDlg('Write a label ?',
 mtconfirmation,[mbYes, mbNo],0)) then form8.show;
end;
end;



procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
bitmap.free;
end;


procedure TForm4.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if llab<0 then begin
  llab:=abs(llab);
  labx[llab]:=x/xgm;laby[llab]:=y/ygm;
  form4.cursor:=crdefault;
  form4.caption:='';
  bitmap.free;
  bitmap:=tbitmap.create;
  bitmap.width:=form4.image1.width;
  bitmap.height:=form4.image1.height;
  bitmap.loadfromfile('c:\tem.scr');
  form4.image1.picture.graphic:=bitmap;
  drawlabels;
  exit;
 end;
 if button=mbleft then if not(form2.checkbox6.checked) then grid(sender);
 if button=mbright then begin
  if(mrYes=MessageDlg('Save bitmap of the screen ?',
  mtconfirmation,[mbYes, mbNo],0)) then begin
   loadopt:=2;form6.show;form6.edit1.text:='*.bmp';
   form6.button2.caption:='save';
   end;
 end;

end;

procedure TForm4.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if llab<0 then begin
  labx[abs(llab)]:=x/xgm;  laby[abs(llab)]:=y/ygm;
  drawlabels;
  exit;
 end;
end;

end.
