unit Unit9;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,plot1;

type
  TGifform = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    OpenDialog1: TOpenDialog;
    Cancel: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Gifform: TGifform;

implementation

uses Unit2, Unit3, Unit10;

{$R *.DFM}

procedure TGifform.Button1Click(Sender: TObject);
begin
opendialog1.initialdir:='c:\windows\temp';
if opendialog1.execute then begin
 edit1.text:=opendialog1.filename;
end;
end;

procedure TGifform.CancelClick(Sender: TObject);
begin
close;
end;

procedure writeblock;{write block buffer and reset ib index}
var i:integer;
begin
 blockwrite(gfile,ib,1);for i:=1 to ib do blockwrite(gfile,block[i],1);ib:=0;
end;

procedure trimtemp;
var td:longint;
begin
 while nb>=8 do begin
  td:=temp - (temp shr 8)shl 8;
  ib:=ib+1;block[ib]:=td;if ib=255 then writeblock;
  temp:=(temp-td) shr 8;
  nb:=nb-8;
 end;
end;

procedure digestcode(code:integer);
begin
 temp:=temp+code shl nb;nb:=nb+compressionsize;trimtemp;
end;

{--------------------------------------------------------------------------}
procedure writegifheaderandgct(var f:file);

procedure writegifheader;
var letter:byte;
begin
letter:=ord('G');blockwrite(f,letter,1);letter:=ord('I');blockwrite(f,letter,1);
letter:=ord('F');blockwrite(f,letter,1);letter:=ord('8');blockwrite(f,letter,1);
letter:=ord('9');blockwrite(f,letter,1);letter:=ord('a');blockwrite(f,letter,1);
end;

procedure writelocalscreendescriptor;
var screenwidth,pixelaspectratio,screenheight,backgroundcolorindex:smallint;
letter:byte;
begin
screenwidth:=gwidth;blockwrite(f,screenwidth,2);
screenheight:=gheight;blockwrite(f,screenheight,2);
letter:=112;blockwrite(f,letter,1);
{packed bits in letter:  0  ... global color table (GCT) will not be defined
                       111  ... color resolution = 7
                         0  ... GCT is not sorted
                       000  ... size of GCT = 7
 letter=(01110000)=112                         }
backgroundcolorindex:=0;blockwrite(f,backgroundcolorindex,1);
pixelaspectratio:=0;blockwrite(f,pixelaspectratio,1);
end;

procedure writeimagedescriptor;
var imagetop,imageleft,imagewidth,imageheight:smallint;letter:byte;
begin
letter:=44;blockwrite(f,letter,1);
imageleft:=0;blockwrite(f,imageleft,2);
imagetop:=0;blockwrite(f,imagetop,2);
imagewidth:=gwidth;blockwrite(f,imagewidth,2);
imageheight:=gheight;blockwrite(f,imageheight,2);
{packed bits: 1     ... local color table
              0     ... interlace flag
              0     ... sort flag
              00    ... reserved
              111   ... size of local color table}
letter:=135;blockwrite(f,letter,1);
end;

procedure writecolortable;
var
i:integer;letter:byte;
begin
for i:=0 to 255 do begin
letter:=tabc[i].red;blockwrite(f,letter,1);
letter:=tabc[i].green;blockwrite(f,letter,1);
letter:=tabc[i].blue;blockwrite(f,letter,1);
end;
end;


begin
 writegifheader;
 writelocalscreendescriptor;
 writeimagedescriptor;
 writecolortable;
 lzwblocksize:=8;blockwrite(f,lzwblocksize,1);
 clearcode:=1 shl lzwblocksize;
 endingcode:=clearcode+1;
 tablemin:=clearcode+2;
 compressionsize:=lzwblocksize+1;
 ib:=0;{number of bytes in byte string block}
 nb:=0;{number of bits in temp*4}
 temp:=0;{where packed bits are stored}
 icc:=0;{control last code in figure}
 np:=tablemin-1;
 digestcode(clearcode);
 currentmax:=(1 shl compressionsize) - 1;
end;
{-----------------------------writegifheaderandgct /end of---------------------}

function isin(sp:integer;sc:byte;var index:integer):boolean;
var i:integer;
begin
 for i:=tablemin to np do begin
  if (table[i].code=sc) and (table[i].prefix=sp) then begin
   index:=i;isin:=true;exit;
  end;
 end;
 isin:=false;
end;

function code(cl:tcolor):byte;
var dd,dist,blue,green,red:tcolor;
i,icl:byte;
{find closest entry in the table}
begin
 cl:=cl-(cl shr 24)shl 24;
 blue:=cl shr 16;green:=(cl-blue shl 16)shr 8;red:=cl-blue shl 16-green shl 8;
 icl:=0;
 dist:=abs(tabc[0].red-red)+abs(tabc[0].blue-blue)+abs(tabc[0].green-green);
 for i:=1 to ncolor do begin
  dd:=abs(tabc[i].red-red)+abs(tabc[i].blue-blue)+abs(tabc[i].green-green);
  if dd<dist then begin dist:=dd;icl:=i;end;
 end;
 code:=icl
end;

procedure increasecompresisonsize;
begin inc(compressionsize);currentmax:=(1 shl compressionsize) - 1;
end;


procedure reinitializetable;
begin;
 temp:=temp+clearcode shl nb;nb:=nb+12;trimtemp;
 np:=tablemin-1;
 compressionsize:=lzwblocksize+1;
 currentmax:=(1 shl compressionsize) - 1;
 temp:=temp+clearcode shl nb;nb:=nb+compressionsize;trimtemp;
end;


procedure takestream(Kode:byte);
{gets new pixel and encodes it,first point sepparately}
begin
{  if (Kode<0) or (Kode>255) then showmessage('Invalid code');}
  if isin(prefix,Kode,index) then begin
   {if [.c.]K was in the table, put it into prefix and go to next pixel}
   prefix:=index;
   icc:=0;
  end else begin {prefix+Kode=[.c.]K not in the table}
   inc(np);table[np].prefix:=prefix;table[np].code:=Kode;{add [.c.]K to the table}
   digestcode(prefix);{output code for prefix}
   {check last np in the table?}
   if (np=currentmax)and (compressionsize=12) then reinitializetable;
   if np>currentmax then increasecompresisonsize;
   prefix:=Kode;{put Kode into prefix}
   icc:=1;
  end;
end;

procedure writegifend;var letter:byte;
begin
 if icc=0 then digestcode(prefix);
 digestcode(endingcode);
 if nb>0 then begin
  ib:=ib+1;block[ib]:=temp;writeblock;
 end;
 letter:=0;blockwrite(gfile,letter,1);{end of figure}
 letter:=59;blockwrite(gfile,letter,1);{end of GIF}
end;

procedure encode(var bitmap:tbitmap;ii:integer);
var x,y:integer;
cl:tcolor;
begin
 for y:=0 to bitmap.height-1 do begin
  form4.caption:='encoding row '+inttostr(y)+' of '+inttostr(bitmap.height-1);
  for x:=0 to bitmap.width-1 do begin
   cl:=bitmap.canvas.pixels[x,y];
   if (ii>0) or((x>0)or(y>0)) then takestream(code(cl));
  end;
 end;
end;

procedure getcolortable(var bitmap:tbitmap);
label l1;
var
x,y:integer;
dd,red,green,blue,cl:longint;
i,n:integer;
occ:array[0..255] of longint;
icl,dist:word;
begin
 for i:=0 to 255 do begin tabc[i].red:=0;tabc[i].green:=0;tabc[i].blue:=0;occ[i]:=0;end;
 {check number of different colors in the bitmap}
 n:=-1;

 for y:=0 to bitmap.height-1 do begin
 form4.caption:='getting colors of row '+inttostr(y)+' of '+inttostr(bitmap.height-1);
 for x:=0 to bitmap.width-1 do begin

  cl:=bitmap.canvas.pixels[x,y];cl:=cl-(cl shr 24)shl 24;
  blue:=cl shr 16;green:=(cl-blue shl 16)shr 8;red:=cl-blue shl 16-green shl 8;
  {?is this point in the table?}
  for i:=0 to n do begin
   if (tabc[i].red=red)and(tabc[i].blue=blue)and(tabc[i].green=green)then begin
    occ[i]:=occ[i]+1;goto l1;
   end;{yes, take next pixel}
  end;
  {point is not there:}
  if n<255 then begin
   {if there is still a place, add this new point to the table}
   inc(n);tabc[n].red:=red;tabc[n].blue:=blue;tabc[n].green:=green;inc(occ[n]);
  end else begin
   {no space left, find closest and adjust weighted average}
   icl:=0;
   dist:=abs(tabc[0].red-red)+abs(tabc[0].blue-blue)+abs(tabc[0].green-green);
   for i:=1 to n do begin
    dd:=abs(tabc[i].red-red)+abs(tabc[i].blue-blue)+abs(tabc[i].green-green);
    if dd<dist then begin dist:=dd;icl:=i;end;
   end;
   tabc[icl].red:=(tabc[icl].red*occ[icl]+red) div (occ[icl]+1);
   tabc[icl].blue:=(tabc[icl].blue*occ[icl]+blue) div (occ[icl]+1);
   tabc[icl].green:=(tabc[icl].green*occ[icl]+green) div (occ[icl]+1);
   occ[icl]:=occ[icl]+1;
  end;

 l1:
 end;
 end;
 showmessage(inttostr(n+1)+' colors');
 ncolor:=n;
end;


procedure TGifform.Button2Click(Sender: TObject);
var mwidth,mheight,i,ytotal,im:integer;
 obd:TRect;
begin
form2.button7.caption:='... working';
gwidth:=strtoint(edit2.text);gheight:=strtoint(edit3.text);
nchop:=(gwidth*gheight) div bmsize +1;
if nchop>nbmmax then begin showmessage(' Too many bitmaps');exit;end;
ytotal:=0;
for i:=0 to nchop-2 do begin
 bmys[i]:=bmsize div gwidth;
 ytotal:=ytotal+bmys[i];
end;
if ytotal <gheight then begin
 bmys[nchop-1]:=gheight-ytotal;
end else begin
 nchop:=nchop-1;
end;
gfilename:=edit1.text+'.gif';
plotter:=false;
lprint:=false;
lgif:=true;
igif:=1;

{plot it on the screen to get number of colors}
lgrid:=form2.checkbox1.checked;
val(form2.edit7.text,cop,im);
val(form2.edit8.text,com,im);
mwidth:=strtoint(form2.edit15.text);
mheight:=strtoint(form2.edit16.text);
if mwidth>gwidth then mwidth:=gwidth;
if mheight>gheight then mheight:=gheight;
form4.clientwidth:=mwidth;
form4.clientheight:=mheight;
form4.top:=0;
form4.left:=0;
form4.show;
bitmap:=tbitmap.create;
bitmap.width:=mwidth;
bitmap.height:=mheight;
igif:=1;
readppp(nd);
Form4.Image1.Picture.Graphic:=Bitmap;
getcolortable(bitmap);
form4.close;{also frees bitmap}

{start to encode:}
assignfile(gfile,gfilename);
rewrite(gfile,1);
writegifheaderandgct(gfile);
igif:=2;
ytop:=0;
for i:=0 to nchop-1 do begin
 bitmap:=tbitmap.create;
 bitmap.width:=gwidth;
 bitmap.height:=bmys[i];
 form4.clientwidth:=bitmap.width;
 form4.clientheight:=bitmap.height;
 form4.top:=0;
 form4.left:=0;
 form4.show;
 readppp(nd);
 if i=0 then begin
  prefix:=code(bitmap.canvas.pixels[0,0]);
 end;
 encode(bitmap,i);
 Form4.Image1.Picture.Graphic:=Bitmap;
 obd.left:=0;
 obd.top:=0;
 obd.right:=bitmap.width;
 obd.bottom:=bitmap.height;
 Form4.Canvas.CopyRect(obd, bitmap.Canvas, obd);
 form4.caption:='Bitmap '+inttostr(i);
 sleep(500);
 ytop:=ytop+bitmap.height;
 form4.close;{includes bitmap.free}
end;
writegifend;
closefile(gfile);
form2.button7.caption:='GIF';
close;
end;

procedure TGifform.FormShow(Sender: TObject);
begin
  edit2.text:=form2.edit15.text;
  edit3.text:=form2.edit16.text;
end;

end.
