unit plot1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Button2: TButton;
    Button5: TButton;
    Button6: TButton;
    CheckBox1: TCheckBox;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button6Click(Sender: TObject);
    procedure readpar(Sender: TObject);
    procedure writepar(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type    tt=record
         red,green,blue:longint;
        end;
        tpc=record
          prefix:integer;
          code:byte;
         end;


const atr:array[1..3,1..3] of real=((1,0,0),(0,1,0),(0,0,1));
nat0=900;
bohr=0.529177;
  Bonding: array[0..87] of real=
{  0du  1h   2he  3li  4be  5b   6c   7n   8o   9f   10ne}
  (0.50,0.55,0.98,1.28,0.95,0.87,0.82,0.80,0.78,0.77,0.76,
{ 11na 12mg 13al 14si 15p  16s  17cl 18ar}
  1.59,1.41,1.23,1.16,1.11,1.07,1.04,1.03,
  2.08,1.79,1.49,1.37,1.27,1.23,1.22,1.22,1.21,1.20,1.22,1.30
  ,1.31,1.27,1.25,1.21,1.19,1.17,2.21,1.96,1.67,1.50,1.39,1.35,1.32,1.30,1.30
  ,1.33,1.39,1.53,1.49,1.46,1.45,1.41,1.38,1.36,2.40,2.03,1.74,1.70,1.70,1.69
  ,1.68,1.67,1.90,1.66,1.64,1.64,1.63,1.62,1.61,1.75,1.61,1.49,1.39,1.35,1.33
  ,1.31,1.32,1.35,1.39,1.54,1.53,1.52,1.51,1.51,1.50,1.49
  ,0.1);

nlab0=100;
llab:integer=0;
lgif:boolean=false;
MTB=4095;
bmsize:longint=480000;{max size of bmps of which gif is composed}
nbmmax=100;{max # of bmps}
var
{variables for gif:}
 ytop,ncolor,ngif:integer;
 opt:array[1..100] of integer;
 line,np:longint;
 bmys:array[0..nbmmax] of integer;
 nchop:longint;
 table:array[0..MTB] of tpc;
 kode,lzwblocksize:byte;
 block:array[1..255] of byte;
 currentmax,icc,nb,compressionsize, clearcode,endingcode,tablemin,
 norb,iorb,prefix,index,iloop:integer;
 temp:longint;
 igif,gwidth,gheight:integer;
 gfilename:string;
 tabc:array[0..255] of tt;
 gfile:file;
 {other variables:}
  bb:array[1..3,1..3] of real;
  labstr:array[1..nlab0] of string;
  labs:array[1..nlab0] of integer;
  labc:array[1..nlab0] of tcolor;
  labn:array[1..nlab0] of string;
  labx:array[1..nlab0] of real;
  laby:array[1..nlab0] of real;
  xgm,ygm,shiftx,shifty:integer;
  ros,zoom:single;
  Form1: TForm1;
  cop,com:single;
  lsprint,lprint:boolean;
  lgrid:boolean;
  loadopt:integer;
  i0,j0,k0:longint;{x-axis # of points}
  filename:string;
  moreorbitals,plotter:boolean;
  fhgl:textfile;
  bitmap:tbitmap;
  list:array[1..100] of integer;
  nd,noa:integer;
  f1:file;
  buff,buffp:array[1..64000] of single;
  fp:textfile;
  startdir,tol:string;
  fbbb,fpot:textfile;
  r:array[1..nat0,1..3] of double;
  q:array[1..nat0] of double;
 lpot:boolean;
 ib:longint;
 natoms,iat1,iat2,iat3:integer;
 qatoms:array[1..nat0] of double;
 ratoms:array[1..3,1..nat0] of double;


  procedure ri4(var f:file;var a:longint);
  procedure rr8(var f:file;var a:double);
  procedure rr4(var f:file;var a:single);
  procedure setlabels(nd,i0,j0,k0:integer;dx,dy,dz:real);
  procedure loadorb;
  procedure writeparf;

implementation

uses Unit2, unit3, Unit6, Unit7, Unit11;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
close;
end;

procedure setlabels(nd,i0,j0,k0:integer;dx,dy,dz:real);
var t:string; a:real;
begin
t:='Grid '+inttostr(i0)+' x '+inttostr(j0);
if (nd=3) or (nd=4) then t:=t+' x '+inttostr(k0);
form2.label9.caption:=t;
str(dx*bohr:6:2,t);
form2.label10.caption:='Tick (A): '+t;
str(dy*bohr:6:2,t);
form2.label10.caption:=form2.label10.caption+' x '+t;
str(dz*bohr:6:2,t);
if nd>2 then form2.label10.caption:=form2.label10.caption+' x '+t;

a:=i0*dx*0.529177;str(a:5:2,t);
form7.label6.caption:='Xmax = '+t;
form2.label17.caption:='Size '+t;
a:=j0*dy*0.529177;str(a:5:2,t);
form7.label5.caption:='Ymax = '+t;
form2.label17.caption:=form2.label17.caption+' x '+t;
if(nd>2) then begin
 a:=k0*dz*0.529177;str(a:5:2,t);
 form7.label4.caption:='Zmax = '+t;
 form2.label17.caption:=form2.label17.caption+' x '+t;
end;
 form2.label17.caption:=form2.label17.caption+' A';
end;

procedure TForm1.Button3Click(Sender: TObject);
{test file 2D}
var filt:file;
    it,i,j:smallint;
    dx,dy,x,y,x0,y0:single;
    name:string[81];noa:longint;
    a4:single;
begin
form2.label1.caption:='Step Size';
assignfile(filt,'den.ppp');rewrite(filt,1);
name:='Test Graph';
for i:=length(name)+1 to 80 do name[i]:=' ';
for i:=0 to 81 do blockwrite(filt,name[i],1);
it:=2;
blockwrite(filt,it,2);
i0:=80;j0:=20;
blockwrite(filt,i0,2);blockwrite(filt,j0,2);
x0:=-5;y0:=-5;dx:=10/i0;dy:=10/j0;
setlabels(it,i0,j0,j0,dx,dy,dy);
blockwrite(filt,x0,4);blockwrite(filt,y0,4);
blockwrite(filt,dx,4);blockwrite(filt,dy,4);
for j:=0 to j0 do begin
 y:=y0+j*dy;
 for i:=0 to i0 do begin
  x:=x0+i*dx;
  a4:=sin(x)*sin(y)*sin(x*x+y*y);
  blockwrite(filt,a4,4);
 end;
end;
noa:=0;
blockwrite(filt,noa,4);
closefile(filt);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
zoom:=strtofloat(form2.edit3.text);
form2.show;
end;

procedure TForm1.Button4Click(Sender: TObject);
{test 3D file}
var filt:file;
    it,i,j,k:smallint;
    dx,dy,dz,x0,z0,y0:single;
    x,y,z:real48;
    name:string[81];
    noa:longint;
    f4:single;
begin
form2.label1.caption:='Limit';
assignfile(filt,'den.ppp');rewrite(filt,1);
name:='Test Graph - an f-orbital';
for i:=length(name)+1 to 80 do name[i]:=' ';
blockwrite(filt,name,82);
it:=3;
blockwrite(filt,it,2);
i0:=20;j0:=20;k0:=20;
blockwrite(filt,i0,2);blockwrite(filt,j0,2);blockwrite(filt,k0,2);
x0:=-5;y0:=-5;z0:=-5;
dx:=10/i0;dy:=10/j0;dz:=10/k0;
setlabels(it,i0,j0,k0,dx,dy,dz);
blockwrite(filt,x0,4);blockwrite(filt,y0,4);blockwrite(filt,z0,4);
blockwrite(filt,dx,4);blockwrite(filt,dy,4);blockwrite(filt,dz,4);
for k:=0 to k0 do begin
 z:=z0+k*dz;
 for j:=0 to j0 do begin
  y:=y0+j*dy;
  for i:=0 to i0 do begin
   x:=x0+i*dx;
   f4:=(x*x-y*y)*exp(-x*x-y*y-z*z);
   blockwrite(filt,f4,4);
  end;
 end;
end;
noa:=0;
blockwrite(filt,noa,4);
closefile(filt);
end;

procedure rr8(var f:file;var a:double);
{reads a real*8 number from an unformatted Fortran record}
type p=^buf;
     buf=record
      a8:double;
     end;
var i:integer; pp:p;ib:array[1..8] of byte;
begin
 for i:=1 to 8 do blockread(f,ib[8-i+1],1);
 pp:=@ib[1];
 a:=pp^.a8;
end;

procedure rr4(var f:file;var a:single);
{reads a real*4 number from an unformatted Fortran record}
type p=^buf;
     buf=record
      a4:single;
     end;
var i:integer; pp:p;ib:array[1..4] of byte;
begin
 for i:=1 to 4 do blockread(f,ib[4-i+1],1);
 pp:=@ib[1];
 a:=pp^.a4;
end;

procedure ri4(var f:file;var a:longint);
{reads an integer*4 number from an unformatted Fortran record}
type p=^buf;
     buf=record
      a4:longint;
     end;
var i:integer; pp:p;ib:array[1..4] of byte;
begin
 for i:=1 to 4 do blockread(f,ib[4-i+1],1);
 pp:=@ib[1];
 a:=pp^.a4;
end;

procedure ri2(var f:file;var a:smallint);
{reads an integer*2 number from an unformatted Fortran record}
type p=^buf;
     buf=record
      a4:smallint;
     end;
var i:integer; pp:p;ib:array[1..2] of byte;
begin
 for i:=1 to 2 do blockread(f,ib[2-i+1],1);
 pp:=@ib[1];
 a:=pp^.a4;
end;
procedure empty;
var ii:integer;
begin {empty temporary buffer when full}
 if nd=4 then begin
  for ii:=1 to ib do begin
   blockwrite(f1,buff[ii],4);blockwrite(f1,buffp[ii],4);
  end;
 end else begin
  for ii:=1 to ib do blockwrite(f1,buff[ii],4);
 end;
 ib:=0;
end;

procedure writeparf;
var i:integer;
    fp:textfile;
begin
 assignfile(fp,'c:\den.par');
 {$I-}
 rewrite(fp);
 if IOResult<>0 then exit;
 {$I+}
 writeln(fp,getcurrentdir);

 writeln(fp,form7.edit1.text);
 writeln(fp,form7.edit2.text);
 writeln(fp,form7.edit3.text);
 writeln(fp,form7.edit4.text);
 writeln(fp,form7.edit5.text);
 writeln(fp,form7.edit6.text);
 writeln(fp,form7.edit7.text);
 writeln(fp,form7.edit8.text);
 writeln(fp,form7.edit9.text);
 writeln(fp,form7.edit10.text);
 writeln(fp,form7.edit11.text);
 writeln(fp,form7.edit12.text);
 writeln(fp,form7.edit13.text);
 writeln(fp,form7.edit14.text);
 writeln(fp,form7.edit15.text);
 writeln(fp,form7.edit16.text);
 writeln(fp,form7.edit17.text);
 writeln(fp,form7.edit18.text);
 writeln(fp,form7.edit19.text);
 writeln(fp,form7.edit20.text);
 writeln(fp,form7.edit21.text);
 writeln(fp,form7.edit22.text);
 writeln(fp,form7.edit23.text);
 writeln(fp,form2.edit1.text);
 writeln(fp,form2.edit3.text);
 writeln(fp,form2.edit4.text);
 writeln(fp,form2.edit5.text);
 writeln(fp,form2.edit7.text);
 writeln(fp,form2.edit8.text);
 writeln(fp,form2.edit9.text);
 writeln(fp,form2.edit10.text);
 writeln(fp,form2.edit11.text);
 writeln(fp,form2.edit12.text);
 writeln(fp,form2.edit13.text);
 writeln(fp,form2.edit14.text);

 for i:=1 to 100 do opt[i]:=0;
 if form1.checkbox1.checked then opt[1]:=1;
 if form1.checkbox2.checked then opt[2]:=1;

 for i:=1 to 100 do writeln(fp,opt[i]);
 closefile(fp);
end;

procedure readparf;
var i:integer;
    s:string;
    a:real;
    fp:textfile;
begin
 assignfile(fp,'c:\den.par');
 reset(fp);
 readln(fp);
 readln(fp,a); form7.edit1.text:=floattostr(a);
 readln(fp,a); form7.edit2.text:=floattostr(a);
 readln(fp,a); form7.edit3.text:=floattostr(a);
 readln(fp,a); form7.edit4.text:=floattostr(a);
 readln(fp,a); form7.edit5.text:=floattostr(a);
 readln(fp,a); form7.edit6.text:=floattostr(a);
 readln(fp,a); form7.edit7.text:=floattostr(a);
 readln(fp,a); form7.edit8.text:=floattostr(a);
 readln(fp,a); form7.edit9.text:=floattostr(a);
 readln(fp,s); form7.edit10.text:=s;
 readln(fp,s); form7.edit11.text:=s;
 readln(fp,s); form7.edit12.text:=s;
 readln(fp,s); form7.edit13.text:=s;
 readln(fp,s); form7.edit14.text:=s;
 readln(fp,s); form7.edit15.text:=s;
 readln(fp,s); form7.edit16.text:=s;
 readln(fp,s); form7.edit17.text:=s;
 readln(fp,s); form7.edit18.text:=s;
 readln(fp,s); form7.edit19.text:=s;
 readln(fp,s); form7.edit20.text:=s;
 readln(fp,s); form7.edit21.text:=s;
 readln(fp,s); form7.edit22.text:=s;
 readln(fp,s); form7.edit23.text:=s;

 readln(fp,s); form2.edit1.text:=s;
 readln(fp,s); form2.edit3.text:=s;
 readln(fp,s); form2.edit4.text:=s;
 readln(fp,s); form2.edit5.text:=s;
 readln(fp,s); form2.edit7.text:=s;
 readln(fp,s); form2.edit8.text:=s;
 readln(fp,s); form2.edit9.text:=s;
 readln(fp,s); form2.edit10.text:=s;
 readln(fp,s); form2.edit11.text:=s;
 readln(fp,s); form2.edit12.text:=s;
 readln(fp,s); form2.edit13.text:=s;
 readln(fp,s); form2.edit14.text:=s;
 
 for i:=1 to 100 do readln(fp,opt[i]);
 closefile(fp);
 if opt[1]=1 then form1.checkbox1.checked:=true;
 if opt[2]=1 then form1.checkbox2.checked:=true;
end;

procedure loadorb;
{loading iorb from gaussian text cube}
var ii,i,j,k,iproc,iprocold:integer;
nct,nc:longint;
a4:single;
begin
 ib:=0;
 np:=(k0+1)*(j0+1)*(i0+1);
 nc:=0;iprocold:=0;
 form1.button1.visible:=true;
 form1.button1.caption:='';
 for i:=0 to i0 do begin
  for j:=0 to j0 do begin
   nct:=0;
   for k:=0 to k0 do begin
    nc:=nc+1;iproc:=(100*nc) div np;
    if iproc>=iprocold then begin
     form1.button1.caption:=inttostr(iproc)+' %';
     iprocold:=iproc;
    end;

    ib:=ib+1;

    for ii:=1 to norb do begin
     nct:=nct+1;
     read(fbbb,a4);if ii=iorb then buff[ib]:=a4;
     if (nct div 6)*6 = nct then readln(fbbb);
     if nd=4 then begin
      read(fpot,a4);if ii=iorb then buffp[ib]:=a4;
      if (nct div 6)*6 = nct then readln(fpot);
     end;
    end;
    if ((nct div 6)*6 <> nct)and(k=k0) then begin
     readln(fbbb);if nd=4 then readln(fpot);
    end;

    if ib=64000 then empty;

   end;{k}
  end;{j}
 end;{i}
 {empty the rest of temporary buffer:}
 empty;
 blockwrite(f1,noa,4);
 for i:=1 to noa do for j:=1 to 3 do blockwrite(f1,r[i,j],8);
 for i:=1 to noa do blockwrite(f1,q[i],8);
 closefile(f1);
 with form1 do begin
  button1.caption:='Close';
  button1.visible:=true;
  button2.visible:=true;
  button3.visible:=true;
  button4.visible:=true;
  caption:=tol;
 end;

 closefile(fbbb);
 if lpot then closefile(fpot);
 zoom:=strtofloat(form2.edit3.text);
 form2.show;
end;{loadorb}

procedure loadden;
{loading density from gaussian text cube}
var i,j,k,iproc,iprocold:integer;
nct,nc:longint;
begin
 ib:=0;
 np:=(k0+1)*(j0+1)*(i0+1);
 nc:=0;iprocold:=0;
 form1.button1.visible:=true;
 form1.button1.caption:='';
 for i:=0 to i0 do begin
  for j:=0 to j0 do begin
   form1.caption:=inttostr(i)+' '+inttostr(j)+' '+inttostr(line);
   nct:=0;
   for k:=0 to k0 do begin
    nc:=nc+1;iproc:=(100*nc) div np;
    if iproc>iprocold then begin
     form1.button1.caption:=inttostr(iproc)+' %';
     iprocold:=iproc;
    end;

    ib:=ib+1;

     nct:=nct+1;
     read(fbbb,buff[ib]);
     if ((nct div 6)*6 = nct)or(k=k0) then begin readln(fbbb);line:=line+1;end;
     if nd=4 then begin
      read(fpot,buffp[ib]);
      if ((nct div 6)*6 = nct)or(k=k0) then readln(fpot);
     end;

    if ib=64000 then empty;

   end;{k}
   line:=line+1;
  end;{j}
 end;{i}
 {empty the rest of temporary buffer:}
 empty;
 blockwrite(f1,noa,4);
 for i:=1 to noa do for j:=1 to 3 do blockwrite(f1,r[i,j],8);
 for i:=1 to noa do blockwrite(f1,q[i],8);
 closefile(f1);
 with form1 do begin
  button1.caption:='Close';
  button1.visible:=true;
  button2.visible:=true;
  button3.visible:=true;
  button4.visible:=true;
  caption:=tol;
 end;
 closefile(fbbb);
 if lpot then closefile(fpot);
 zoom:=strtofloat(form2.edit3.text);
 form2.show;
end;{loadden}

procedure TForm1.Button5Click(Sender: TObject);
var whats,ts:string;
i,ic,nrepeat:integer;
idum:smallint;
t:string[82];
x0,y0,z0,dx,dy,dz:single;
begin
 if checkbox1.checked then begin
  {$I-}
  assignfile(fp,'c:\den.par');
  reset(fp);
  {$I+}
  if IOREsult<>0 then startdir:=getcurrentdir else begin
   read(fp,startdir);closefile(fp);
  end;

  if(checkbox2.checked) then nrepeat:=3 else nrepeat:=1;

  for ic:=1 to nrepeat do begin
   if(nrepeat=1)then opendialog1.title:=' Define the density file:' else begin
    case ic of 1:opendialog1.title:=' VX:';
               2:opendialog1.title:=' VY:';
               3:opendialog1.title:=' VZ:';
    end;
   end;
   opendialog1.initialdir:=startdir;
   if opendialog1.execute then begin

    if(nrepeat=1)then begin
     if(mrYes = MessageDlg('Add a potential map?',mtconfirmation,[mbYes, mbNo],0)) then begin
      opendialog2.title:=' Define the potential file:';
      opendialog2.initialdir:=startdir;
      if opendialog2.execute then begin
       ts:=opendialog2.filename;
       assignfile(fpot,ts);
       reset(fpot);
       lpot:=true;
      end else exit;
     end else lpot:=false;{potential map}
    end else lpot:=false;

    if lpot then nd:=4 else nd:=3;
    with form1 do begin
     tol:=caption;
     caption:='Re-writing the fortran file ...';
     button1.visible:=false;button2.visible:=false;
     button3.visible:=false;button4.visible:=false;
    end;
    if(nrepeat=1)then assignfile(f1,'den.ppp') else begin
     case ic of 1:assignfile(f1,'denx.ppp');
                2:assignfile(f1,'deny.ppp');
                3:assignfile(f1,'denz.ppp');
     end;
    end;
    rewrite(f1,1);
    assignfile(fbbb,opendialog1.filename);
    reset(fbbb);
    readln(fbbb,t);line:=1;
    readln(fbbb,whats);line:=line+1;
    if copy(whats,2,23)='SCF Molecular Orbitals' then begin
     moreorbitals:=true;
    end else begin
     moreorbitals:=false;
    end;
    readln(fbbb,noa,x0,y0,z0);noa:=abs(noa);line:=line+1;
    readln(fbbb,i0,dx);i0:=i0-1;line:=line+1;
    readln(fbbb,j0,dy,dy);j0:=j0-1;line:=line+1;
    readln(fbbb,k0,dz,dz,dz);k0:=k0-1;line:=line+1;
    idum:=0;
    for i:=1 to noa do readln(fbbb,idum,q[i],r[i,1],r[i,2],r[i,3]);line:=line+noa;
    natoms:=noa;
    if idum=0 then noa:=noa*1;
    for i:=1 to noa do begin r[i,1]:=(r[i,1]-x0);r[i,2]:=(r[i,2]-y0);r[i,3]:=(r[i,3]-z0);end;
    if lpot then for i:=1 to noa+6 do readln(fpot);
    blockwrite(f1,t,82);blockwrite(f1,nd,2);
    blockwrite(f1,i0,2);blockwrite(f1,j0,2);blockwrite(f1,k0,2);
    blockwrite(f1,x0,4);blockwrite(f1,y0,4);blockwrite(f1,z0,4);
    blockwrite(f1,dx,4);blockwrite(f1,dy,4);blockwrite(f1,dz,4);
    setlabels(nd,i0,j0,k0,dx,dy,dz);
    if moreorbitals then begin
     read(fbbb,norb);for i:=1 to norb do read(fbbb,list[i]);readln(fbbb);
     line:=line+1;
     if norb>1 then begin
      form11.show;
      form11.label1.caption:='Found orbitals: ';
      for i:=1 to norb do form11.label1.caption:=form11.label1.caption+inttostr(list[i])+' ';
      form11.edit1.text:=inttostr(list[1]);
      exit;
     end else begin norb:=1;iorb:=1;loadorb;end;
    end else loadden;

   end else exit;{opendialog1.execute}
  end;{ic=1..nrepeat}
 end else begin
  loadopt:=1;
  form6.edit1.text:='*.scr';
  form6.button2.caption:='Load';
  form6.show;
 end;
end;


procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var i:integer;ok:char;
begin
ok:=key;
i:=ord(ok) ;
if (i=8) or (i=27) then close;
end;

procedure TForm1.Button6Click(Sender: TObject);
var filt:file;
    it,i,j,k:smallint;
    dx,dy,dz,x0,z0,y0:single;
    x,y,z:real48;
    name:string[81];
    noa:longint;
    f4:single;

begin
form2.label1.caption:='Limit';
assignfile(filt,'den.ppp');rewrite(filt,1);
name:='Test Graph of a potential- an f-orbital on a sphere';
for i:=length(name)+1 to 80 do name[i]:=' ';
blockwrite(filt,name,82);
it:=4;
blockwrite(filt,it,2);
i0:=20;j0:=20;k0:=20;
blockwrite(filt,i0,2);blockwrite(filt,j0,2);blockwrite(filt,k0,2);
x0:=-5;y0:=-5;z0:=-5;
dx:=10/i0;dy:=10/j0;dz:=10/k0;
setlabels(it,i0,j0,k0,dx,dy,dz);
blockwrite(filt,x0,4);blockwrite(filt,y0,4);blockwrite(filt,z0,4);
blockwrite(filt,dx,4);blockwrite(filt,dy,4);blockwrite(filt,dz,4);
for k:=0 to k0 do begin
 z:=z0+k*dz;
 for j:=0 to j0 do begin
  y:=y0+j*dy;
  for i:=0 to i0 do begin
   x:=x0+i*dx;
   f4:=(x*x+y*y+z*z)*exp(-x*x-y*y-z*z);blockwrite(filt,f4,4);
   f4:=1/27*x*y*exp(-0.1*(x*x+y*y+z*z));blockwrite(filt,f4,4);
  end;
 end;
end;
noa:=0;
blockwrite(filt,noa,4);
closefile(filt);
end;

procedure TForm1.readpar(Sender: TObject);
begin
readparf;
end;

procedure TForm1.writepar(Sender: TObject; var Action: TCloseAction);
begin
writeparf;
end;

end.
